package ru.jimbot;


import java.util.HashMap;
import ru.jimbot.modules.AbstractServer;
import ru.jimbot.modules.AbstractServer;
import ru.jimbot.modules.chat.ChatProps;
import ru.jimbot.modules.chat.ChatServer;
import ru.jimbot.modules.chat.Users;
import ru.jimbot.util.Log;
import ru.jimbot.util.MainProps;

/**
 *   
 * @author ~Jo-MA-Jo~
 */


public class StartServices implements Runnable {
    private Thread th;
    private HashMap<String,AbstractServer> services;
public ChatServer srv2;


    public StartServices(HashMap<String,AbstractServer> srv) {
    services = new HashMap<String,AbstractServer>(srv);
    }


    public void start(){

        th = new Thread(this);
        th.setPriority(Thread.NORM_PRIORITY);
        th.start();
    }

    public synchronized void stop() {
        th = null;
        notify();
    }

    public void run() {
                 
        for(AbstractServer s : services.values()){
            try {


 





                if(s.getProps().isAutoStart()){
                    s.start();
                    int timeOut=MainProps.getIntProperty("timeOut")*1000*s.getProps().getIntProperty("conn.uinCount");
                    Log.info("TimeOut: "+timeOut/1000+" .");
                    th.sleep(timeOut);
                }
            } catch (InterruptedException ex) {
            Log.error("   "+s.getName()+" : "+ex);
            }
        }
        stop();
    }

 }