/**
 * JimBot - Java IM Bot
 * Copyright (C) 2010 JimBot project
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package ru.jimbot.modules.chat;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Random;
import java.util.Vector;

import ru.jimbot.protocol.IcqProtocol;
import ru.jimbot.modules.Cmd;
import ru.jimbot.modules.CommandParser;

/*
*  ChatCommandProc
* public Alisa alisa_strip = null;
*
* if(alisa_strip == null){
* alisa_strip = new Alisa(srv);
* alisa_strip.start();
* }
* if(alisa_strip.commandParse(proc, uin, mmsg)) return;
*
* @author MOBINEXT
*/

public class Alisa implements Runnable {
public String NICK = "";
private Thread th;
int sleepAmount = 1000;
long LastUsage = System.currentTimeMillis(); //  ,   
long cTime=System.currentTimeMillis(); //  ,   
private HashMap<String, Cmd> commands = new HashMap<String, Cmd>();
private CommandParser parser;
private boolean isRun = false;
private ChatServer srv;
private String misc = "";
private String miscr = "";
private String top = "";
private String bottom = "";
private String utop = "";
private String ubottom = "";
private Vector<String> n = new Vector<String>();
private int level = 0;
private ChatCommandProc cmd;

public Alisa(ChatServer s) {
srv = s;
parser = new CommandParser(commands);
init();
}
private void init(){
commands.put("!", new Cmd("!","",1));
commands.put("!", new Cmd("!","",1));
commands.put("!", new Cmd("!","",2));
commands.put("!", new Cmd("!","",2));
}

public boolean commandParse(IcqProtocol proc, String uin, String msg){
int tp = parser.parseCommand(msg);
int tst=0;
if(tp<0)
tst=0;
else
tst = tp;
boolean f = false;
switch (tst){

case 1: //
f = false;
unRun ();
break;
case 2: //


f = true;
Run(proc, uin);
}
return f;
}

private Random r = new Random();
public int getRND(int i){
return r.nextInt(i);
}

private void unRun (){
isRun = false;
stop();
return;
}

private void Run(IcqProtocol proc, String uin){
    if(!ChatProps.getInstance(srv.getName()).getBooleanProperty("al.srtip.on.off")){
 proc.mq.add(uin, "     ...");
return;
    }

if(srv.us.getUser(uin).room != ChatProps.getInstance(srv.getName()).getIntProperty("Alisa.room")){
proc.mq.add(uin, "  : "+ChatProps.getInstance(srv.getName()).getIntProperty("Alisa.room"));
return;
}
if (((System.currentTimeMillis()-LastUsage)>(ChatProps.getInstance(srv.getName()).getIntProperty("Alisa.UsageTime")*60000)) && !isRun) {
isRun = true;
misc = miscs[getRND(miscs.length)];
miscr = miscrs[getRND(miscrs.length)];
top = tops[getRND(tops.length)];
bottom = bottoms[getRND(bottoms.length)];
utop = utops[getRND(utops.length)];
ubottom = ubottoms[getRND(ubottoms.length)];
LastUsage = System.currentTimeMillis();
Enumeration<String> e = srv.cq.uq.keys();
while(e.hasMoreElements()){
String i = e.nextElement();
Users us = srv.us.getUser(i);
if(us.state==UserWork.STATE_CHAT){
n.add(us.localnick);
}
}
proc.mq.add(uin, ";-)");
} else if (isRun) {proc.mq.add(uin, ",    ,    " + ChatProps.getInstance(srv.getName()).getIntProperty("Alisa.room"));}
else proc.mq.add(uin, "  , . ;-)");
return;
}

private String[] miscs = {"", "", "", "", "", "  "};
private String[] miscrs = {"", "", "", "", "", ""};
private String[] tops = {"", "", ""};
private String[] bottoms = {"", "", "", " ", "  ", " ", " "};
private String[] utops = {"", "", " ", " "};
private String[] ubottoms = {"", "  ", " ", " ", " "};
private String[][] stripline = {
{"ACTION    : ?!",
"ACTION     WinAmp`e",
"ACTION      SexMusicFM",
"ACTION    PornoSounds   ",
"ACTION    -    !"},
{"ACTION        - ",
"ACTION         ",
"ACTION      ",
"ACTION    ",
"ACTION     ",
"ACTION      - !"},
{"       ?",
"ACTION      ,    .",
"ACTION ..   - ",
"ACTION      .",
"ACTION  "},
{"ACTION  \"I want to fuck you like an animal. I want to feel you from the inside.\"",
"ACTION  \"I want to fuck you like an animal! My whole existence is gone, you bring me closer to god\"",
"ACTION  \"Sex is natural, sex is fun, sex is best when it's one on one\"",
"ACTION  \"When I think about you I touch myself... I touch myself.\"",
"ACTION  \"You and me baby ain't nothing but mammals, so let's do it like they do on the Discovery channel.\""},
{"ACTION ,         $misr $misc",
"ACTION $misr $misc",
"ACTION    $nick  $misr $misc ,",
"ACTION $misr $misc   $nick       "},
{"-  ?  !",
"         ",
"     !",
"   ?",
"!   !  !",
"   ,    !"},
{"ACTION    ,  ",
"ACTION ",
"ACTION ,      !",
"ACTION    !"},
{"ACTION   $top      .",
"ACTION  $top   $nick",
"ACTION   $top     $nick    ,  ",
"ACTION   $top         ",
"ACTION   $top     "},
{"ACTION         ",
"ACTION   $nick      ",
"ACTION   $nick    ",
"ACTION   ,      $nick   "},
{"ACTION   $bottom    ",
"ACTION   $nick   $bottom",
"ACTION  $bottom     $nick .... =) ",
"ACTION  $bottom        ,     "},
{"ACTION  $bottom ,     ,     !!",
"ACTION  $misc       ,    ",
"ACTION  $top           $nick"},
{"ACTION     $utop,   $nick      ,      ",
"ACTION    $utop ,   $nick    $nick   3 ",
"ACTION    ,    $utop    ",
"ACTION    $utop,        $utop  \"\"    $nick",
"ACTION   $utop          , ......."},
{"ACTION   $nick        ",
"ACTION     -    ",
"ACTION       ",
"ACTION     $nick   \",     ? \"",
"ACTION  $misc  ,     $nick,  .....",
"ACTION           "},
{"ACTION    $nick;     $ubottom;     .. ",
"ACTION   $nick,  $ubottom      $nick ",
"ACTION  $ubottom $nick   \"Ta Da!\""},
{"ACTION  ,          ",
"ACTION   ,   ,  ,        !",
"ACTION      ",
"ACTION     "},
{"ACTION        -",
"ACTION      $nick ,  ",
"ACTION       .     ...",
"ACTION    \"\"      ...",
"ACTION     ",
"ACTION    $nick         "},
{"ACTION          ",
"ACTION     ....",
"ACTION       ,  ",
"ACTION    $nick ,  ,        ",
"ACTION     $nick ...      !       -"},
{"    ????",
"     ?  ------!!!",
"ACTION  $nick ,  :\"      \"",
"ACTION   ,  ,    ...."},
{"ACTION   ,      ,     ,           ",
"ACTION  ,              ,   ",
"ACTION    ,     $nick         "},
{"ACTION     , , ---- ...      "},
{"ACTION  $top   ,          ",
"ACTION  $ubottom  $nick  : \"        , ?\"",
"ACTION   $utop  ,   ,       $nick"}
};

public boolean testTime() {
return ((System.currentTimeMillis()-cTime)>(ChatProps.getInstance(srv.getName()).getIntProperty("Alisa.sayAloneTime")*1000));
}
private void timeEvent(){
if(testTime() && isRun){
cTime = System.currentTimeMillis();
if ( level > 20 ) {
isRun = false;
level = 0;
} else {
String msg = stripline[level][getRND(stripline[level].length)];
msg = msg.replace("$misc", misc);
msg = msg.replace("$misr", miscr);
msg = msg.replace("$top", top);
msg = msg.replace("$bottom", bottom);
msg = msg.replace("$utop", utop);
msg = msg.replace("$ubottom", ubottom);
msg = msg.replace("$nick", n.get(getRND(n.size())));
level = level  + 1;
say(msg, ChatProps.getInstance(srv.getName()).getIntProperty("Alisa.room"));
}

}
}
public void say(String m, int room){
String s = "";
if(m.indexOf("ACTION")==0)
s = m.replaceFirst("ACTION", "* " + NICK);
else
s += NICK + " " + ChatProps.getInstance(srv.getName()).getStringProperty("Alisa.delimiter") + " " + m;
srv.cq.addMsg(s,"",room);
}

public void start(){
th = new Thread(this);
th.setPriority(Thread.NORM_PRIORITY);
th.start();
}

public synchronized void stop() {
th = null;
notify();
}

public void run() {
Thread me = Thread.currentThread();
while (th == me) {
timeEvent();
try {
th.sleep(sleepAmount);
} catch (InterruptedException e) { break; }
}
th=null;
}
}