/**
 * JimBot - Java IM Bot
 * Copyright (C) 2010 JimBot project
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package ru.jimbot.modules.chat;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Enumeration;
import java.util.Vector;
import java.util.HashMap;
import java.util.Random;
import ru.jimbot.Messages;
import ru.jimbot.modules.Cmd;
import ru.jimbot.modules.CommandExtend;
import ru.jimbot.protocol.IcqProtocol;
import ru.jimbot.modules.CommandParser;
import ru.jimbot.util.Log;
import ru.jimbot.util.ShootingProp;

/**
 *  
 *  ChatCommandProc
 *
 * public GamesServis games;
 *
 * games = new GamesServis(this);
 *
 *  
 * if(games.commandGames(proc, uin, mmsg)) return;
 *
 * @author Warik777
 */

public class GamesServis{
private HashMap<String, Cmd> commands = new HashMap<String, Cmd>();
private CommandParser parser;
private ChatCommandProc cmd;
public ChatServer srv;
private HashMap<String, CommandExtend> games;
private Random r = new Random();

/**Creates a new instance of GamesServis*/
public GamesServis(ChatCommandProc c) {
parser = new CommandParser(commands);
cmd = c;
games = new HashMap<String, CommandExtend>();
init();
}


private void init() {
//
commands.put("!", new Cmd("!", "", 1));
commands.put("!", new Cmd("!", "$n", 2));

commands.put("!", new Cmd("!", "$n $n", 4));

commands.put("!", new Cmd("!", "", 6));
commands.put("!", new Cmd("!", "", 6));
commands.put("!", new Cmd("!", "$n $n", 7));
commands.put("!", new Cmd("!", "$n $n", 8));
commands.put("!", new Cmd("!", "$n", 9));
commands.put("!", new Cmd("!", "$n", 10));
commands.put("!", new Cmd("!", "$n", 11));
commands.put("!",new Cmd("!","",12));
commands.put("!", new Cmd("!", "", 13));
commands.put("!", new Cmd("!","$s",15));
commands.put("!", new Cmd("!","$s",15));
commands.put("!", new Cmd("!", "$n", 16));
commands.put("!",new Cmd("!","$c $n",18));
commands.put("!",new Cmd("!","$n",19));
commands.put("!", new Cmd("!", "", 20));
commands.put("!salary",new Cmd("!salary","",21));
commands.put("!",new Cmd("!","",21));
commands.put("!", new Cmd("!", "$n $n $c", 22));
commands.put("!",new Cmd("!","$n $n",23));
commands.put("!",new Cmd("!","$n $c",24));
commands.put("!",new Cmd("!","",25));
commands.put("!", new Cmd("!", "$n $n", 26));
commands.put("!", new Cmd("!", "$n $n", 27));
commands.put("!",new Cmd("!","",28));
commands.put("!", new Cmd("!", "", 29));
commands.put("!", new Cmd("!", "$n", 30));




}

public boolean commandGames(IcqProtocol proc, String uin, String mmsg) {

String msg = mmsg.trim();
        int tp = 0;
        if(games.containsKey(uin))
            if(!games.get(uin).isExpire())
                tp = parser.parseCommand(games.get(uin).getCmd());
            else {
            tp = parser.parseCommand(msg);
            games.remove(uin);
            } else
tp = parser.parseCommand(msg);
int tst=0;
if(tp<0)
tst = 0;
else
tst = tp;
boolean f = true;
switch (tst) {
//
case 1:
commandBytilochka(proc, uin, parser.parseArgs(mmsg), mmsg);
break;
case 2:
commandRyletka(proc, uin, parser.parseArgs(mmsg), mmsg);
break;

case 4:
commandBones(proc, uin, parser.parseArgs(mmsg));
break;
//case 5:
//commandOrugie(proc, uin, mmsg, parser.parseArgs(mmsg));
//break;
case 6:
commandCasino(proc, uin);
break;
case 7:
commandRespect(proc, uin, parser.parseArgs(mmsg));
break;
case 8:
commandAntiRespect(proc, uin, parser.parseArgs(mmsg));
break;
case 9:
commandPatron(proc, uin, mmsg, parser.parseArgs(mmsg));
break;
case 10:
commandStr(proc, uin, mmsg, parser.parseArgs(mmsg));
break;
case 11:
commandApt(proc, uin, mmsg, parser.parseArgs(mmsg));
break;
case 12:
commandGames(proc, uin);
break;
case 13:
commandhelpbank(proc, uin);
break;

case 15:
commandBomba(proc, uin, parser.parseArgs(mmsg), mmsg);
break;
case 16:
commandGranati(proc, uin, mmsg, parser.parseArgs(mmsg));
break;

case 18:
commandKazinoVibrat(proc, uin, parser.parseArgs(mmsg), mmsg);
break;
case 19:
commandKazinoStavit(proc, uin, parser.parseArgs(mmsg), mmsg);
break;
case 20:
commandRich(proc, uin, mmsg, parser.parseArgs(mmsg));
break;
case 21:
commandSalary(proc, uin);
break;
case 22:
commandStavka(proc, uin, parser.parseArgs(mmsg));
break;
case 23:
commandNaperstki(proc, uin, parser.parseArgs(msg));
break;
case 24:
commandMoreLess(proc, uin, parser.parseArgs(msg));
break;
case 25:
commandBesProigrishnaya(proc, uin);
break;
case 26:
commandRum(proc, uin, mmsg, parser.parseArgs(mmsg));
break;
case 27:
commandLecit(proc, uin, parser.parseArgs(mmsg));
break;
case 28:
commandimm(proc, uin);
break;
case 29:
GamesWar(proc, uin, parser.parseArgs(msg), mmsg);
break;
case 30:
GamesBattle(proc, uin, parser.parseArgs(msg), mmsg);
break;

default:
f = false;
break;
}
return f;
}

//
/**
* 
* !
*/
public void commandBytilochka(IcqProtocol proc, String uin, Vector v, String mmsg) {
if (!cmd.isChat(proc, uin) && !cmd.psp.testAdmin(uin)) return;
if (!(cmd.psp.getBooleanProperty("chat.Bytilochka"))) return;
try {
String g = "";
Users uss = cmd.srv.us.getUser(uin);
Enumeration<String> e = cmd.srv.cq.uq.keys();
while (e.hasMoreElements()) {
String i = e.nextElement();
Users us = cmd.srv.us.getUser(i);
if (us.state == UserWork.STATE_CHAT) {
if (us.room == uss.room && !cmd.srv.us.authorityCheck(us.id, "invisible")) {
g += us.id + ";";
}
}
}
String[] gg = g.split(";");
int k = (int) ((Math.random() * gg.length));
String s = cmd.psp.loadText("./text/" + cmd.srv.getName() + "/Bytilochka.txt");
String[] ss = s.split("<end>");
int R = (int) ((Math.random() * ss.length));
Users u = cmd.srv.us.getUser(Integer.parseInt(gg[k]));
if (uss.id == 0) {
proc.mq.add(uin, "  ");
return;
}
if (uss.state != UserWork.STATE_CHAT) {
proc.mq.add(uin, "    .");
return;
}
if (uss.room != cmd.psp.getIntProperty("room.igra.bytilochka")) {
proc.mq.add(uin, "    " + cmd.psp.getIntProperty("room.igra.bytilochka") + "  "+cmd.srv.us.getRoom(cmd.psp.getIntProperty("room.igra.bytilochka")).getName());
return;
}
if (u.id == uss.id) {
proc.mq.add(uin, uss.localnick + "[" + uss.id + "]" + "         ");
return;
}
//  
cmd.srv.cq.addMsg(cmd.radm.NICK()+": " + uss.localnick + "[" + uss.id + "]" + "  " + ss[R] + " () " + u.localnick + "|" + u.id + "|", "", uss.room);
proc.mq.add(uin, "  " + ss[R] + " () " + u.localnick + "[" + u.id + "]");
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}

/**
* 
* @param proc
* @param uin
* @param v
* @param mmsg
*/
public void commandRyletka(IcqProtocol proc, String uin, Vector v, String mmsg) {
if (!cmd.isChat(proc, uin) && !cmd.psp.testAdmin(uin)) return;
if (!(cmd.psp.getBooleanProperty("chat.Ryletka"))) return;
try {
int s = (Integer) v.get(0); //  
int numb = (int) ((Math.random() * cmd.psp.getIntProperty("chislo.kick.ryletka"))); //     0  10
int num = (int) ((Math.random() * cmd.psp.getIntProperty("chislo.ryletka1"))); //    0  3
Users uss = cmd.srv.us.getUser(uin);
if (uss.room != cmd.psp.getIntProperty("room.igra.ryletka")){
proc.mq.add(uin, "    " + cmd.psp.getIntProperty("room.igra.ryletka") + "  " +cmd.srv.us.getRoom(cmd.psp.getIntProperty("room.igra.ryletka")).getName() + ""); //   
return;
}
int moder_id = 0; //  
String r = "!"; // 
if (s > cmd.psp.getIntProperty("chislo.ryletka1")) {
proc.mq.add(uin, "    1  "+cmd.psp.getIntProperty("chislo.ryletka1"));
return;
}
//     cmd.srv.cq.addMsg(" :   : (" + num + ") ,  " + uss.localnick + "|" + uss.id + "|" + " : (" + s + ")", "", uss.room);
if (s == num) {
cmd.srv.cq.addMsg(cmd.radm.NICK()+":  ! " + uss.localnick + "[" + uss.id + "]" + "     " + numb + " ", "", uss.room);
proc.mq.add(uin, " :   : (" + num + ") ,    : (" + s + ") ,  !  !");
// ....
proc.mq.add(uin, "      " + numb + " . :     !");
cmd.tkick(proc, uin, numb, moder_id, r);
} else {
int gold = uss.ball+cmd.psp.getIntProperty("ryletka.bonus");
uss.ball=gold;
proc.mq.add(uin,":    !  () "+ cmd.psp.getIntProperty("ryletka.bonus")+ " " + cmd.psp.getStringProperty("valuta.chat") + " ,   = " + uss.ball);
cmd.srv.cq.addMsg(cmd.radm.NICK()+":   !  " + uss.localnick + "[" + uss.id + "]" + "          " + numb + " ", "", uss.room);
}
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}



/**
 *  
 * @param proc
 * @param uin
 * @param v
 */
public void commandBones(IcqProtocol proc, String uin, Vector v) {
if (!(cmd.isChat(proc, uin))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
if (!(cmd.psp.getBooleanProperty("chat.Bones"))) return;
try {
Users uss = cmd.srv.us.getUser(uin);
if (uss.room != cmd.psp.getIntProperty("bones.room")) {
proc.mq.add(uin, Messages.getString("ChatCommandProc.commandBones.0", new Object[] { Integer.valueOf(cmd.psp.getIntProperty("bones.room")) }));
return;
}
int i = ((Integer)v.get(0)).intValue();
if ((i < 0) || (i > cmd.psp.getIntProperty("bones.max"))) {
proc.mq.add(uin, Messages.getString("ChatCommandProc.commandBones.2", new Object[] { Integer.valueOf(cmd.psp.getIntProperty("bones.max")) }));
return;
}
int s = 0;
if (i == 0)
s = cmd.psp.getIntProperty("bones.def");
else
s = i;
if (uss.ball < s) {
proc.mq.add(uin, Messages.getString("ChatCommandProc.commandBones.1"));
return;
}
int b1 = (int)(Math.random() * 6.0);
int b2 = (int)(Math.random() * 6.0);
int b3 = (int)(Math.random() * 6.0);
int b4 = (int)(Math.random() * 6.0);
cmd.srv.cq.addMsg(cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " + Messages.getString("ChatCommandProc.commandBones.3", new Object[] { Integer.valueOf(b1), Integer.valueOf(b2), uss.localnick, Integer.valueOf(b3), Integer.valueOf(b4) })+" "+cmd.psp.getStringProperty("valuta.chat"), uss.sn, uss.room);
proc.mq.add(uin, cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " + Messages.getString("ChatCommandProc.commandBones.4", new Object[] { Integer.valueOf(b1), Integer.valueOf(b2), Integer.valueOf(b3), Integer.valueOf(b4) }));
int k1 = b1 + b2;
int k2 = b3 + b4;
if (k1 == k2) {
cmd.srv.cq.addMsg(cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " + Messages.getString("ChatCommandProc.commandBones.5", new Object[] { Integer.valueOf(b1), Integer.valueOf(b2), uss.localnick, Integer.valueOf(b3), Integer.valueOf(b4) })+" "+cmd.psp.getStringProperty("valuta.chat"), uss.sn, uss.room);
proc.mq.add(uin, cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " + Messages.getString("ChatCommandProc.commandBones.6", new Object[] { Integer.valueOf(b1), Integer.valueOf(b2), Integer.valueOf(b3), Integer.valueOf(b4) }));
} else {
if (k1 > k2) {
int i1 = uss.ball - s;
uss.ball = i1;
cmd.srv.cq.addMsg(cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " + Messages.getString("ChatCommandProc.commandBones.7", new Object[] { Integer.valueOf(k1), uss.localnick, Integer.valueOf(k2), Integer.valueOf(i) })+" "+cmd.psp.getStringProperty("valuta.chat"), uss.sn, uss.room);
proc.mq.add(uin, cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " + Messages.getString("ChatCommandProc.commandBones.8", new Object[] { Integer.valueOf(k1), Integer.valueOf(k2), Integer.valueOf(i) }));
} else {
int i2 = uss.ball + s;
uss.ball = i2;
cmd.srv.cq.addMsg(cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " + Messages.getString("ChatCommandProc.commandBones.9", new Object[] { Integer.valueOf(k1), uss.localnick, Integer.valueOf(k2), Integer.valueOf(i) })+" "+cmd.psp.getStringProperty("valuta.chat"), uss.sn, uss.room);
proc.mq.add(uin, cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " + Messages.getString("ChatCommandProc.commandBones.10", new Object[] { Integer.valueOf(k1), Integer.valueOf(k2), Integer.valueOf(i) }));
}
uss.basesn = proc.baseUin;
cmd.srv.us.updateUser(uss);
}
} catch (Exception ex) {
ex.printStackTrace();
Log.error(": " + ex.getMessage());
proc.mq.add(uin, Messages.getString("ChatCommandProc.err", new Object[] { ex.getMessage() }));
}
}

///**
// * 
// * @param proc
// * @param uin
// * @param v
// */
//public void commandOrugie(IcqProtocol proc, String uin, String tmsg, Vector v){
//if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) return;
//if (!(cmd.auth(proc, uin, "game"))) return;
//try {
//String dol = (String)v.get(0);
//Users uss = cmd.srv.us.getUser(uin);
//if ((uss.room != cmd.psp.getIntProperty("orugie.room"))){
//proc.mq.add(uin, "     [" + cmd.psp.getIntProperty("orugie.room") + "] " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("orugie.room")).getName() + "" );
//return;
//}
//int uroven5;
//int gold;
//int uroven;
//String gold3;
//if (dol.equals("1")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.ES")){
//proc.mq.add(uin, " : " + uss.ball +  " " + cmd.psp.getStringProperty("valuta.chat")+" ,      .");
//return;
//}
//uroven5 = uss.orujie = 1;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.ES");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.ES");
//uss.age = uroven;
//gold3 = uss.pushka = "ES FIVE-SEVEN";
//uss.pushka= gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     ES FIVE-SEVEN...  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat") +".     "+cmd.psp.getIntProperty("orug.ES"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   ES FIVE-SEVEN", uss.sn, uss.room);
//}else if (dol.equals("2")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.pcm")){
//proc.mq.add(uin, " : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+ ",      .");
//return;
//}
//uroven5 = uss.orujie = 2;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.pcm");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.pcm");
//uss.age = uroven;
//gold3 = uss.pushka = "";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     << >>..  : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat") +".     "+cmd.psp.getIntProperty("orug.pcm"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   << >>", uss.sn, uss.room);
//}else if (dol.equals("3")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.pm")){
//proc.mq.add(uin, " : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 3;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.pm");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.pm");
//uss.age = uroven;
//gold3 = uss.pushka = "";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     <<  ()>>..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.pm"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   <<  ()>>", uss.sn, uss.room);
//}else if (dol.equals("4")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.uzi")){
//proc.mq.add(uin, " : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 4;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.uzi");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.uzi");
//uss.age = uroven;
//gold3 = uss.pushka = "";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     <<>>..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.uzi"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   <<>>", uss.sn, uss.room);
//}else if (dol.equals("5")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.g3")){
//proc.mq.add(uin, " : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 5;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.g3");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.g3");
//uss.age = uroven;
//gold3 = uss.pushka = "G3";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     <<G3>>..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.g3"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   <<G3>>", uss.sn, uss.room);
//}else if (dol.equals("6")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.ak27")){
//proc.mq.add(uin, " : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 6;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.ak27");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.ak27");
//uss.age = uroven;
//gold3 = uss.pushka = "AK-47";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     <<AK-47>>..  : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat") +".     "+cmd.psp.getIntProperty("orug.ak27"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   <<AK-47>>", uss.sn, uss.room);
//}else if (dol.equals("7")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.aug")){
//proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 7;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.aug");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.aug");
//uss.age = uroven;
//gold3 = uss.pushka = "AUG";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     <<Steyer AUG>>..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.aug"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   <<Steyer AUG>>", uss.sn, uss.room);
//}else if (dol.equals("8")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.SHOTGUN")){
//proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 8;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.SHOTGUN");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.SHOTGUN");
//uss.age = uroven;
//gold3 = uss.pushka = "LEONE YG 1265 AUTO SHOTGUN";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     LEONE YG 1265 AUTO SHOTGUN..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.SHOTGUN"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   LEONE YG 1265 AUTO SHOTGUN", uss.sn, uss.room);
//}else if (dol.equals("9")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.UMP45")){
//proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 9;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.UMP45");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.UMP45");
//uss.age = uroven;
//gold3 = uss.pushka = "KM UMP45";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     KM UMP45..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.UMP45"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   KM UMP45", uss.sn, uss.room);
//}else if (dol.equals("10")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.SCHMIDT")){
//proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 10;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.SCHMIDT");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.SCHMIDT");
//uss.age = uroven;
//gold3 = uss.pushka = "SCHMIDT SCOUT";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     SCHMIDT SCOUT..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.SCHMIDT"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   SCHMIDT SCOUT", uss.sn, uss.room);
//}else if (dol.equals("11")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.KRIEG")){
//proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 11;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.KRIEG");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.KRIEG");
//uss.age = uroven;
//gold3 = uss.pushka = "KRIEG 550 COMMANDO";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     KRIEG 550 COMMANDO ..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.KRIEG"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   KRIEG 550 COMMANDO ", uss.sn, uss.room);
//}else if (dol.equals("12")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.MAGNUM")){
//proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 12;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.MAGNUM");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.MAGNUM");
//uss.age = uroven;
//gold3 = uss.pushka = "MAGNUM SNIPER RIFLE";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     MAGNUM SNIPER RIFLE ..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.MAGNUM"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   MAGNUM SNIPER RIFLE", uss.sn, uss.room);
//}else if (dol.equals("13")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.D3")){
//proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 13;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.D3");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.D3");
//uss.age = uroven;
//gold3 = uss.pushka = "D3/AU-1";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     D3/AU-1 ..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.D3"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   D3/AU-1", uss.sn, uss.room);
//}else if (dol.equals("14")){
//if (uss.ball < cmd.psp.getIntProperty("orugie.M249")){
//proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
//return;
//}
//uroven5 = uss.orujie = 14;
//uss.orujie = uroven5;
//gold = uss.ball - cmd.psp.getIntProperty("orugie.M249");
//uss.ball = gold;
//uroven = uss.age + cmd.psp.getIntProperty("orug.M249");
//uss.age = uroven;
//gold3 = uss.pushka = "M249";
//uss.pushka = gold3;
//cmd.srv.us.updateUser(uss);
//proc.mq.add(uin, "  ,     M249..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+cmd.psp.getIntProperty("orug.M249"));
//cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   M249", uss.sn, uss.room);
//}else{
//proc.mq.add(uin,
//"! :" +
//"\n   -   " +
//"\n  1) -  ES FIVE-SEVEN  " + cmd.psp.getIntProperty("orugie.ES") +
//"\n  2) -    " + cmd.psp.getIntProperty("orugie.pcm") +
//"\n  3) -   ()  " + cmd.psp.getIntProperty("orugie.pm") +
//"\n  4) -    " + cmd.psp.getIntProperty("orugie.uzi") +
//"\n  5) - G3  " + cmd.psp.getIntProperty("orugie.g3") +
//"\n  6) - AK-47  " + cmd.psp.getIntProperty("orugie.ak27") +
//"\n  7) - Steyer AUG  " + cmd.psp.getIntProperty("orugie.aug")+
//"\n  8) -  LEONE YG 1265 AUTO SHOTGUN  " + cmd.psp.getIntProperty("orugie.SHOTGUN") +
//"\n  9) - KM UMP45  " + cmd.psp.getIntProperty("orugie.UMP45") +
//"\n  10) - SCHMIDT SCOUT   " + cmd.psp.getIntProperty("orugie.SCHMIDT") +
//"\n  11) - KRIEG 550 COMMANDO  " + cmd.psp.getIntProperty("orugie.KRIEG") +
//"\n  12) - MAGNUM SNIPER RIFLE  " + cmd.psp.getIntProperty("orugie.MAGNUM") +
//"\n  13) - D3/AU-1  " + cmd.psp.getIntProperty("orugie.D3")+
//"\n  14) -  M249   " + cmd.psp.getIntProperty("orugie.M249") );
//}
//}
//catch (Exception ex) {
//ex.printStackTrace();
//proc.mq.add(uin, " " + ex.getMessage()); }
//}

/**
 *  
 * @param proc
 * @param uin
 */
public void commandCasino(IcqProtocol proc, String uin) {
if (!(cmd.isChat(proc, uin))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
if (!(cmd.psp.getBooleanProperty("chat.Casino"))) return;
try {
int win2;
Users uss = cmd.srv.us.getUser(uin);
if (uss.room != cmd.psp.getIntProperty("casino.room")) {
proc.mq.add(uin, "      "+ cmd.psp.getIntProperty("casino.room")+"  " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("casino.room")).getName());
return;
}
if (uss.ball < cmd.psp.getIntProperty("casino.price")) {
proc.mq.add(uin, "   .  "+cmd.psp.getIntProperty("casino.price")+" "+cmd.psp.getStringProperty("valuta.chat")+",     " + uss.ball+" "+cmd.psp.getStringProperty("valuta.chat"));
return;
}
int number1 = (int)(Math.random() * cmd.psp.getIntProperty("casino.amount"));
int number2 = (int)(Math.random() * cmd.psp.getIntProperty("casino.amount"));
int number3 = (int)(Math.random() * cmd.psp.getIntProperty("casino.amount"));
int payment = uss.ball - cmd.psp.getIntProperty("casino.price");
cmd.srv.cq.addMsg(cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " "+ uss.localnick + "  ...  ... ... ...    "+" = "+number1+" = "+ number2+" = "+number3+" = ", uss.sn, uss.room);
proc.mq.add(uin, cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " + "  ...    "+" = "+number1+" = "+number2+" = "+number3+" =");
if ((number1 != number2) && (number1 != number3) && (number2 != number3)) {
uss.ball = payment;
cmd.srv.cq.addMsg(cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " +"  ..."+uss.localnick+" - !!!", uss.sn, uss.room);
proc.mq.add(uin, cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " +"  ...     .      "+cmd.psp.getIntProperty("casino.price")+" "+cmd.psp.getStringProperty("valuta.chat"));
}
if ((number1 == number2) && (number3 != number2)) {
win2 = payment + cmd.psp.getIntProperty("casino.win2");
uss.ball = win2;
cmd.srv.cq.addMsg(cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " +"  ...  "+uss.localnick+"  "+ cmd.psp.getIntProperty("casino.win2")+" "+cmd.psp.getStringProperty("valuta.chat"), uss.sn, uss.room);
proc.mq.add(uin, cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " +"  ...   "+cmd.psp.getIntProperty("casino.win2")+" "+cmd.psp.getStringProperty("valuta.chat")+".      "+ cmd.psp.getIntProperty("casino.price")+" "+cmd.psp.getStringProperty("valuta.chat"));
}
if ((number2 == number3) && (number1 != number2)) {
win2 = payment + cmd.psp.getIntProperty("casino.win2");
uss.ball = win2;
cmd.srv.cq.addMsg(cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " +"  ...  "+uss.localnick+"  "+ cmd.psp.getIntProperty("casino.win2")+" "+cmd.psp.getStringProperty("valuta.chat"), uss.sn, uss.room);
proc.mq.add(uin, cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " +"  ...   "+cmd.psp.getIntProperty("casino.win2")+" "+cmd.psp.getStringProperty("valuta.chat")+".      "+ cmd.psp.getIntProperty("casino.price")+" "+cmd.psp.getStringProperty("valuta.chat"));
}
if ((number1 == number3) && (number1 != number2)) {
win2 = payment + cmd.psp.getIntProperty("casino.win2");
uss.ball = win2;
cmd.srv.cq.addMsg(cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " +"  ...  "+uss.localnick+"  "+ cmd.psp.getIntProperty("casino.win2")+" "+cmd.psp.getStringProperty("valuta.chat"), uss.sn, uss.room);
proc.mq.add(uin, cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " +"  ...   "+cmd.psp.getIntProperty("casino.win2")+" "+cmd.psp.getStringProperty("valuta.chat")+".      "+ cmd.psp.getIntProperty("casino.price")+" "+cmd.psp.getStringProperty("valuta.chat"));
}
if ((number1 == number2) && (number3 == number2)) {
int win3 = payment + cmd.psp.getIntProperty("casino.win3");
uss.ball = win3;
cmd.srv.cq.addMsg(cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " +" 3  ...  "+uss.localnick+"  "+cmd.psp.getIntProperty("casino.win3")+" "+cmd.psp.getStringProperty("valuta.chat")+" ...  !!!", uss.sn, uss.room);
proc.mq.add(uin, cmd.radm.NICK() + cmd.psp.getStringProperty("chat.delimiter") + " " +" 3  ...   "+cmd.psp.getIntProperty("casino.win3")+" "+cmd.psp.getStringProperty("valuta.chat")+".      "+cmd.psp.getIntProperty("casino.price")+" "+cmd.psp.getStringProperty("valuta.chat"));
}
uss.basesn = proc.baseUin;
cmd.srv.us.updateUser(uss);
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, Messages.getString("ChatCommandProc.err", new Object[] { ex.getMessage() })); }
}

/**
 *  
 * @param proc
 * @param uin
 * @param v
 */
public void commandAntiRespect(IcqProtocol proc, String uin, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
try{
int s = (Integer)v.get(0);
Users us = cmd.srv.us.getUser(s);
Users uss = cmd.srv.us.getUser(uin);
if(us.id==0){
proc.mq.add(uin,"      ");
return;
}
proc.mq.add(uin,"    [" + us.id + "]" + us.localnick + "");
int uroven = us.country-cmd.psp.getIntProperty("vs.antirespect");
us.country=uroven;
cmd.srv.us.updateUser(us);
cmd.srv.getIcqProcess(us.basesn).mq.add(us.sn,"  : [" + uroven + "]     [" + uss.id + "]" + uss.localnick + "");
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}

/**
 * 
 * @param proc
 * @param uin
 * @param v
 */
public void commandRespect(IcqProtocol proc, String uin, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
try{
int s = (Integer)v.get(0);
Users us = cmd.srv.us.getUser(s);
Users uss = cmd.srv.us.getUser(uin);
if(us.id==0)
{
proc.mq.add(uin,"      ");
return;
}

proc.mq.add(uin,"    [" + us.id + "]" + us.localnick + "");
int uroven = us.country+cmd.psp.getIntProperty("vs.respect");
us.country=uroven;
cmd.srv.us.updateUser(us);
cmd.srv.getIcqProcess(us.basesn).mq.add(us.sn,"  : [" + uroven + "]     [" + uss.id + "]" + uss.localnick + "");
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}

/**
 * ++ DIMAX
 * @param proc
 * @param uin
 * @param v
 */
public void commandLecit(IcqProtocol proc, String uin, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
try{
int s = (Integer)v.get(0);
Users us = cmd.srv.us.getUser(s);
Users uss = cmd.srv.us.getUser(uin);
if(us.id==0)
{
proc.mq.add(uin,"      ");
return;
}
if(us.hp>=100)
{
proc.mq.add(uin,"  ");
return;
}
if(us.id==uss.id)
{
proc.mq.add(uin,"  ");
return;
}


proc.mq.add(uin,"    [" + us.id + "]" + us.localnick + "");
int uroven = us.hp+cmd.psp.getIntProperty("help.zdorove");
us.hp=uroven;
cmd.srv.us.updateUser(us);
cmd.srv.getIcqProcess(us.basesn).mq.add(us.sn,"  : [" + uroven + "]     [" + uss.id + "]" + uss.localnick + "");
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}


/**
 *  
 * @param proc
 * @param uin
 * @param tmsg
 * @param v
 */
public void commandPatron(IcqProtocol proc, String uin, String tmsg, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
try {
int i = ((Integer)v.get(0)).intValue();
Users uss = cmd.srv.us.getUser(uin);
if (uss.orujie == 0) {
proc.mq.add(uin, ": " + uss.localnick + "    ?    ");
return;
}
if (i < 0) {
proc.mq.add(uin, " ,    ...");
return;
}
if (i >cmd.psp.getIntProperty("ogr.patron")) {
proc.mq.add(uin, ": " + uss.localnick + "   " + i + " ,   ,    30 \n  - 10"+ " " + cmd.psp.getStringProperty("valuta.chat"));
return;
}
if (uss.ball < (cmd.psp.getIntProperty("price.patron") * i)) {
proc.mq.add(uin, "\n:    !   - "+cmd.psp.getIntProperty("price.patron")+ " " + cmd.psp.getStringProperty("valuta.chat"));
return;
}
int gold = uss.ball - (cmd.psp.getIntProperty("price.patron")* i);
uss.ball = gold;
int patroni = uss.birthyear + i;
uss.birthyear = patroni;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin, ":   " + i + " ()\n : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat"));
cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " () " + i + " ()", uss.sn, uss.room);
} catch (Exception ex){
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}


/**
 *  
 *     ( ) us.hp
 * @param proc
 * @param uin
 * @param tmsg
 * @param v
 */
public void commandApt(IcqProtocol proc, String uin, String tmsg, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
try {
Users uss = cmd.srv.us.getUser(uin);
if (uss.hp == 100) {
proc.mq.add(uin, "    100%,      ");
return;
}
if (uss.ball < cmd.psp.getIntProperty("aptecka.price")) {
proc.mq.add(uin, "      ");
} else if (uss.ball > cmd.psp.getIntProperty("aptecka.price")) {
int uroven5 = uss.hp + cmd.psp.getIntProperty("aptecka.zdorove");
uss.hp = uroven5; // us.hp ( )
int gold = uss.ball - cmd.psp.getIntProperty("aptecka.price");
uss.ball = gold;
String golds;
golds = uss.hp_ = "";
proc.mq.add(uin, "   ,      " + cmd.psp.getIntProperty("aptecka.price")+ " " + cmd.psp.getStringProperty("valuta.chat") +",   " + uss.hp);
}
}
catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage()); }
}

/**
 * 
 * @param proc
 * @param uin
 */
public void commandimm(IcqProtocol proc, String uin){
try{
Users us = cmd.srv.us.getUser(uin);
if (us.number == 1) {
proc.mq.add(uin, "      .");
return;
}
if (!cmd.psp.getBooleanProperty("imm.on.off")){
    proc.mq.add(uin, "    !");
return;

    }
if (us.ball < cmd.psp.getIntProperty("immm.price")) {
proc.mq.add(uin, "      ");
return;
}
us.number = 1;
int gold = us.ball - cmd.psp.getIntProperty("immm.price");
us.ball = gold;
proc.mq.add(uin, "     ,      " + cmd.psp.getIntProperty("immm.price")+ " " + cmd.psp.getStringProperty("valuta.chat"));

} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}


/**
 *   
 * @param proc
 * @param uin
 */
public void commandGames(IcqProtocol proc, String uin){
try{
String v = cmd.psp.getStringProperty("vic.room");
String n = cmd.psp.getStringProperty("word.room");
proc.mq.add(uin,
" :\n"+
"=====\n"+
" :\n"+
"! <id> -   \n"+
"! <id> -  \n"+
"! <id> -  \n"+
"! < > < > -   \n"+
"! <> -  \n"+
"! -  \n"+
"!  -  \n"+
"! <> - (;;)\n"+
"! <> -  .\n"+
"=====\n"+
" :\n"+
"! <id> -  \n"+
"! <> -  \n"+
"! <id> -   \n"+
"!  -   \n"+
"=====\n"+
"  :\n"+
"! -   \n"+
"======\n"+
" :\n"+
"! -   21\n"+
"! <> <>  -    \n"+
"! -    \n"+
"! <> <> <> -   \n"+
"! <> -  \n"+
"! -    \" \"\n"+
"======\n"+
" :\n"+
"! -   \"   ?\"\n"+
"! -   \n"+
"    \"\": "+v+"\n"+
"    \"\": "+n+"\n"+
"======\n"+
" :\n"+
"! -     ,     !\n"+
"! <text> -     \n"+
"! <0-6> -     \n"+
"! -    ,,\n"+
"! - \n"+
"! - \n"+
"! - \n"

       );
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}

/**
 *  
 * @param proc
 * @param uin
 */
public void commandhelpbank(IcqProtocol proc, String uin){
try{
Users us = cmd.srv.us.getUser(uin);
proc.mq.add(uin,
" :\n"+
"! <> -    \n"+
 "!  <> -  \n"+

"! <> -  "
);
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}


///() 
public void commandBomba(IcqProtocol proc, String uin, Vector v, String mmsg) {
if (!cmd.isChat(proc, uin) && !cmd.psp.testAdmin(uin)) return;
if (!(cmd.psp.getBooleanProperty("chat.bomba"))) return;
try{
int ween;
int lose;
Users uss = cmd.srv.us.getUser(uin);
String cvet = (String)v.get(0);
cvet=cvet.replaceAll("1", "");
cvet=cvet.replaceAll("2", "");
cvet=cvet.replaceAll("3", "");
int t = (int) ((Math.random()*3));
if (cmd.psp.getIntProperty("v.vybros") !=1 && uss.ugroza == 0){
if(uss.room!=cmd.psp.getIntProperty("room.bomba")){
proc.mq.add(uin,"   ["+cmd.psp.getIntProperty("room.bomba")+"] - " +cmd.srv.us.getRoom(cmd.psp.getIntProperty("room.bomba")).getName() + "");
return;
}
    }



String s =";;";
String[] ss = s.split(";");
int i = (int) ((Math.random()*3));
String color = ss[i];
if(cvet.equals("") || (cvet.equals(" ")))  {
cvet=cvet.replaceAll("", "1");
cvet=cvet.replaceAll("", "2");
cvet=cvet.replaceAll("","3");
proc.mq.add(uin,"  .\n1 - \n2 - \n3 - \n: ! ");
return;
}

if (cmd.psp.getIntProperty("v.vybros") != 1){
if (uss.hp < cmd.psp.getIntProperty("bomba.hp")){
proc.mq.add(uin,uss.localnick+ ",  ,    .     " + cmd.psp.getIntProperty("bomba.hp")+"%");
return;
}
}
if(cvet.equals(ss[i])) {
    if (cmd.psp.getIntProperty("v.vybros") == 1 && uss.ugroza == 1){
uss.ugroza =0;
}
ween = uss.ball +cmd.psp.getIntProperty("bomba.ween");
uss.ball=ween;
cmd.srv.cq.addMsg(":  ! [" + uss.id + "] " + uss.localnick + "      !", "", uss.room);
proc.mq.add(uin,uss.localnick+ ",  !     " + ss[i] + ",   " + cvet +  ",  !    !     "+ cmd.psp.getIntProperty("bomba.ween")+" "+cmd.psp.getStringProperty("valuta.chat"));

} else {
if (cmd.psp.getIntProperty("v.vybros") == 1 && uss.ugroza == 1){
uss.ugroza =1;
}else{
lose = uss.hp - cmd.psp.getIntProperty("bomba.hp");
uss.hp=lose;
    }
if (cmd.psp.getIntProperty("v.vybros")==0){
proc.mq.add(uin,uss.localnick+ ",   !     !    " + ss[i] + ",   " + cvet +  ",  !     !      "+t+" !     "+ cmd.psp.getIntProperty("bomba.hp")+ "%");
cmd.srv.cq.addMsg(":  !  [" + uss.id + "] " + uss.localnick + "       "+t+" !", "", uss.room);
cmd.tkick(proc, uin, t, 0, "     !");
}else{
proc.mq.add(uin,uss.localnick+ ",   !     !    " + ss[i] + ".\n    -    ,   "+ cmd.psp.getIntProperty("v.antivybrosroom")+"] - " +cmd.srv.us.getRoom(cmd.psp.getIntProperty("v.antivybrosroom")).getName());

}
}
cmd.srv.us.updateUser(uss);
}
catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}

/**
 * 
 * @param proc
 * @param uin
 * @param tmsg
 * @param v
 */
public void commandGranati(IcqProtocol proc, String uin, String tmsg, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
try {
int i = ((Integer)v.get(0)).intValue();

Users uss = cmd.srv.us.getUser(uin);
if ((uss.room != cmd.psp.getIntProperty("orugie.room"))){
proc.mq.add(uin, "     [" + cmd.psp.getIntProperty("orugie.room") + "] " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("orugie.room")).getName() + "" );
return;
}
if (i == 0) {
proc.mq.add(uin, " :    \n"
        + "1  - "+ cmd.psp.getIntProperty("price.garanata")+ " " + cmd.psp.getStringProperty("valuta.chat")        + "\n"
        + "   ! <>");
return;
}

if (i < 0) {
proc.mq.add(uin, " ,    ...");
return;
}
if (i > cmd.psp.getIntProperty("granat.lim")) {
proc.mq.add(uin, ": " + uss.localnick + "   " + i + " ,   ,    "+cmd.psp.getIntProperty("granat.lim")+ " \n  - "+  cmd.psp.getIntProperty("price.garanata") + " " + cmd.psp.getStringProperty("valuta.chat"));
return;
}
if (uss.ball < cmd.psp.getIntProperty("price.garanata") * i) {
proc.mq.add(uin, "\n  - "+ cmd.psp.getIntProperty("price.garanata")+ " " + cmd.psp.getStringProperty("valuta.chat"));
return;
}
int gold = uss.ball - (cmd.psp.getIntProperty("price.garanata") * i);
uss.ball = gold;
int granati = uss.bomba +i;
uss.bomba = granati;
int uroven = uss.age + cmd.psp.getIntProperty("orug.granata");
uss.age = uroven;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin, ":   " + i + " )\n : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat"));
cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " () " + i + " ", uss.sn, uss.room);
} catch (Exception ex){
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}

/**
 

/**
 * 
 * @param proc
 * @param uin
 * @param v
 * @param mmsg
 */
public void commandKazinoVibrat(IcqProtocol proc, String uin, Vector v, String mmsg) {
if (!cmd.isChat(proc, uin) && !cmd.psp.testAdmin(uin)) return;
try{
String t = (String)v.get(0);
int k = (Integer)v.get(1);
Users uss = cmd.srv.us.getUser(uin);
String s = ";;;";
String[] ss = s.split(";");
int R = (int) ((Math.random()*ss.length));
if (uss.room != cmd.psp.getIntProperty("chat.GameRoom1")){
proc.mq.add(uin, "    : " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("chat.GameRoom1")).getName() + "[" + cmd.psp.getIntProperty("chat.GameRoom1") + "].");
return;
}
if(t.equals("") || t.equals(" ")){
proc.mq.add(uin,"  \n\n\n\n\n! <> <>");
return;
}
if(k == 0){
proc.mq.add(uin,"   ");
return;
}
if(k>cmd.psp.getIntProperty("koll.igra.kazino") || k<0){
proc.mq.add(uin,"    0  " + cmd.psp.getIntProperty("koll.igra.kazino"));
return;
}
if(uss.ball<=0){
proc.mq.add(uin,"  ,    ");
return;
}
if (ss[R].equals(t)) {
int vig = k*cmd.psp.getIntProperty("koll2.igra.kazino");
int reiting = uss.ball + vig;
uss.ball = reiting;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin,"       "+ cmd.psp.getIntProperty("koll2.igra.kazino") + "    " + vig +" "+cmd.psp.getStringProperty("valuta.chat"));
cmd.srv.cq.addMsg(cmd.radm.NICK()+": " + uss.localnick + "[" + uss.id + "]  " + vig +" "+cmd.psp.getStringProperty("valuta.chat")+ ",   " + t + "("+k+")" + ",   " + ss[R], "", uss.room);
} else {
int vig = k;
int reiting = uss.ball - vig;
uss.ball = reiting;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin," .   " + k +" "+cmd.psp.getStringProperty("valuta.chat")+ ".     " + vig + " ");
cmd.srv.cq.addMsg(cmd.radm.NICK()+": " + uss.localnick + "[" + uss.id + "]  " + vig +" "+cmd.psp.getStringProperty("valuta.chat")+ ",   " + t + "("+k+")" + ",   " + ss[R], "", uss.room);
}
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}

public void commandKazinoStavit(IcqProtocol proc, String uin, Vector v, String mmsg) {
if (!cmd.isChat(proc, uin) && !cmd.psp.testAdmin(uin)) return;
try{
int s = (Integer)v.get(0);
int num = (int) ((Math.random()*10));
Users uss = cmd.srv.us.getUser(uin);
if (uss.room != cmd.psp.getIntProperty("room.igra.kazino")){
proc.mq.add(uin, "    " + cmd.psp.getIntProperty("room.igra.kazino") + "  "+ cmd.srv.us.getRoom(cmd.psp.getIntProperty("room.igra.kazino")).getName());
return;
}
if(uss.ball<=0){
proc.mq.add(uin,"  ,    ");
return;
}
if(s>cmd.psp.getIntProperty("koll.igra.kazino") || s<0){
proc.mq.add(uin,"    0  " + cmd.psp.getIntProperty("koll.igra.kazino"));
return;
}
if (s==num) {
int vig = s*cmd.psp.getIntProperty("koll2.igra.kazino");
int reiting = uss.ball + vig;
uss.ball = reiting;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin,"      " + cmd.psp.getIntProperty("koll2.igra.kazino") + "     " + vig +" "+cmd.psp.getStringProperty("valuta.chat")+ ",    " + num);
cmd.srv.cq.addMsg(cmd.radm.NICK()+": " + uss.localnick + "[" + uss.id + "]  " + vig+" "+cmd.psp.getStringProperty("valuta.chat") + ",    " + num, "", uss.room);
} else {
int vig = s;
int reiting = uss.ball - vig;
uss.ball = reiting;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin," .   " + s+" "+cmd.psp.getStringProperty("valuta.chat") + ".     " + vig + " ,    " + num);
cmd.srv.cq.addMsg(cmd.radm.NICK()+": " + uss.localnick + "[" + uss.id + "]  " + vig +" "+cmd.psp.getStringProperty("valuta.chat")+ " ,    " + num, "", uss.room);
}
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}

/**
 *  20-  
 * @param proc
 * @param uin
 * @param tmsg
 * @param v
 */
public void commandRich(IcqProtocol proc, String uin, String tmsg, Vector v)
{
if(!(cmd.isChat(proc,uin)) && !(cmd.psp.testAdmin(uin))) return;
if(!(cmd.auth(proc,uin, "rich"))) return;
try{
String s = "20-     :\n*******\n";
try{
PreparedStatement pst = cmd.srv.us.db.getDb().prepareStatement("SELECT id, localnick, ball FROM users WHERE ball > 0 ORDER BY ball DESC LIMIT 0,20");
ResultSet rs = pst.executeQuery();
for(int i=0;i<20;i++){
if(rs.next()){
s += " [" + rs.getInt(1) + "] - " + rs.getString(2) + "[" + rs.getInt(3) + " " + cmd.psp.getStringProperty("valuta.chat")+ "]\n";
} else {
break;
}
}
rs.close();
pst.close();
} catch (Exception ex){
ex.printStackTrace();
}
proc.mq.add(uin,s);
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}

/**
 *   
 * @param proc
 * @param uin
 */
public void commandSalary (IcqProtocol proc, String uin) { //!salary (!)
if(!cmd.isChat(proc,uin) && !cmd.psp.testAdmin(uin)) return;
if (!(cmd.auth(proc, uin, "game"))) return;
try {
Users uss = cmd.srv.us.getUser(uin);

if(cmd.srv.us.getZarplata(uss.id)>=1) {
proc.mq.add(uin,"      ");
return;
}
if(cmd.srv.us.getUserGroup(uss.id).equals("user")) {
proc.mq.add(uin, "   ...\n      VIP");
return;
}
int salary = 0;
if (uss.group.equals("vip")) salary = cmd.psp.getIntProperty("salary.vip");
if (uss.group.equals("moder")) salary = cmd.psp.getIntProperty("salary.moder");
if (uss.group.equals("admin")) salary = cmd.psp.getIntProperty("salary.admin");
int money = uss.ball + salary;
uss.ball = money;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin,", ...   " + salary + " " + cmd.psp.getStringProperty("valuta.chat"));
cmd.srv.us.db.event(uss.id, uin, "Rating", uss.id, uss.sn, " ");
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ ex.getMessage());
}
}

/**
 *  
 * @param proc
 * @param uin
 * @param v
 */
public void commandStavka(IcqProtocol proc, String uin, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
if (!(cmd.psp.getBooleanProperty("chat.Stavka"))) return;
try {
int stavka = ((Integer)v.get(0)).intValue();
int num = ((Integer)v.get(1)).intValue();
String rez = (String)v.get(2);
Users uss = cmd.srv.us.getUser(uin);
long iw = System.currentTimeMillis();
if (!(cmd.mobitime.containsKey(uss.sn))) {
cmd.mobitime.put(uss.sn, Long.valueOf(iw));
}else{
long iss = ((Long)cmd.mobitime.get(uss.sn)).longValue();
if (System.currentTimeMillis() - iss < cmd.psp.getIntProperty("chat.TimePause1")){
if (cmd.psp.getBooleanProperty("chat.usepause1")) {
proc.mq.add(uin, ":    " + (cmd.psp.getIntProperty("chat.TimePause1") / 1000) + " ...");
}
return;
}
cmd.mobitime.put(uss.sn, Long.valueOf(iw));
}
Log.talk(uss.sn + "-" + uss.localnick + "  .");
if (uss.room != cmd.psp.getIntProperty("chat.GameRoom1")){
proc.mq.add(uin, "    : " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("chat.GameRoom1")).getName() + "[" + cmd.psp.getIntProperty("chat.GameRoom1") + "].");
return;
}
String[][] chg = { { "0", "ZERRO" }, { "32", "" }, { "15", "" }, { "19", "" }, { "4", "" }, { "21", "" }, { "2", "" }, { "25", "" }, { "17", "" }, { "34", "" }, { "6", "" }, { "27", "" }, { "13", "" }, { "36", "" }, { "11", "" }, { "30", "" }, { "8", "" }, { "23", "" }, { "10", "" }, { "5", "" }, { "24", "" }, { "16", "" }, { "33", "" }, { "1", "" }, { "20", "" }, { "14", "" }, { "31", "" }, { "9", "" }, { "22", "" }, { "18", "" }, { "29", "" }, { "7", "" }, { "28", "" }, { "12", "" }, { "35", "" }, { "3", "" }, { "26", "" } };
int i = (int)(Math.random() * chg.length);
if ((stavka == 0) || (num == 0)){
proc.mq.add(uin, ":   . !  ");
return;
}
if (uss.ball < stavka){
proc.mq.add(uin, ":  : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat") + " ,      .");
return;
}
if ((stavka < cmd.psp.getIntProperty("chat.min.stav")) || (stavka > cmd.psp.getIntProperty("chat.max.stav"))){
proc.mq.add(uin, ":   "+cmd.psp.getIntProperty("chat.min.stav")+"  " +(stavka > cmd.psp.getIntProperty("chat.max.stav")) + " "+ " " + cmd.psp.getStringProperty("valuta.chat"));
return;
}
if (num > chg.length){
proc.mq.add(uin, ":      .");
return;
}
int b = Integer.parseInt(chg[i][0]);
if ((b == 0) && (chg[i][1].equals("ZERRO"))){
proc.mq.add(uin, ": \"ZERRO\"   .");
return;
}
int gold;
if ((b == num) && (chg[i][1].equals(rez))){
int itog = stavka * cmd.psp.getIntProperty("chat.ween.stav");
gold = uss.ball + itog;
uss.ball = gold;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin, ":  \"" + chg[i][0] + " " + chg[i][1] + "\"   " + itog + " " + cmd.psp.getStringProperty("valuta.chat")+ ".");
cmd.srv.cq.addMsg(": " + uss.localnick + "   " + stavka+ " " + cmd.psp.getStringProperty("valuta.chat") + "   " + num + " " + rez + ",  \"" + chg[i][0] + " " + chg[i][1] + "\"   " + itog+ " " + cmd.psp.getStringProperty("valuta.chat"), uss.sn, uss.room);
return;
}
if (chg[i][1].equals(rez)){
int itog2 = stavka / 2;
gold = uss.ball - itog2;
uss.ball = gold;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin, ":  \"" + chg[i][0] + " " + chg[i][1] + "\"   " + itog2 + " " + cmd.psp.getStringProperty("valuta.chat"));
cmd.srv.cq.addMsg(": " + uss.localnick + "   " + stavka + " " + cmd.psp.getStringProperty("valuta.chat") + "   " + num + " " + rez + ",  \"" + chg[i][0] + " " + chg[i][1] + "\"   " + itog2+ " " + cmd.psp.getStringProperty("valuta.chat"), uss.sn, uss.room);
return;
}
if (b == num){
int itog3 = stavka;
gold = uss.ball + itog3;
uss.ball = gold;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin, ":  \"" + chg[i][0] + " " + chg[i][1] + "\"   " + itog3 + " " + cmd.psp.getStringProperty("valuta.chat"));
cmd.srv.cq.addMsg(": " + uss.localnick + "   " + stavka + " " + cmd.psp.getStringProperty("valuta.chat")+ "   " + num + " " + rez + ",  \"" + chg[i][0] + " " + chg[i][1] + "\"   " + itog3 + " " + cmd.psp.getStringProperty("valuta.chat"), uss.sn, uss.room);
return;
}
int itog3 = stavka;
gold = uss.ball - stavka;
uss.ball = gold;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin, ":  \"" + chg[i][0] + " " + chg[i][1] + "\"  .");
cmd.srv.cq.addMsg(": " + uss.localnick + "   " + stavka + " " + cmd.psp.getStringProperty("valuta.chat")+  "   " + num + " " + rez + ",  \"" + chg[i][0] + " " + chg[i][1] + "\", " + stavka + " " + cmd.psp.getStringProperty("valuta.chat")+ "    .", uss.sn, uss.room);
return;
}catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}

/**
*
*-
*/
public void commandMoreLess(IcqProtocol proc, String uin, Vector v){
if(!cmd.auth(proc,uin, "game")) return;
try{
int stavka = (Integer)v.get(0);
String moreless = (String)v.get(1);
boolean more = moreless.trim().toLowerCase().equals("");
Users uss = cmd.srv.us.getUser(uin);
if(uss.room!=cmd.psp.getIntProperty("games.morelessroom")){
proc.mq.add(uin,"       "+cmd.psp.getIntProperty("games.morelessroom")+" ");
return;
}
if (uss.ball < stavka){
proc.mq.add(uin,"    .");
return;
}
if (stavka < cmd.psp.getIntProperty("max.money.bolshe")){
proc.mq.add(uin,"     "+cmd.psp.getIntProperty("max.money.bolshe")+" "+cmd.psp.getStringProperty("valuta.chat"));
return;
}
int number = cmd.radm.getRND(100)+1;
proc.mq.add(uin,"  "+stavka+ "  "+(more ? "":"")+" 50");
String s1=":    ,  *"+number+"*";// 
//  50,     
if((more && number>=50)||(!more && number<=50)){
uss.ball+=stavka;
s1+="\n  "+stavka+ " $!   "+uss.ball+"$";
}else{
uss.ball-=stavka;
s1+="\n  "+stavka+ " $!   "+uss.ball+"$";
}
cmd.srv.us.updateUser(uss);
proc.mq.add(uin,s1);
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}

/**
* 
*/
public void commandNaperstki(IcqProtocol proc, String uin, Vector v){
if(!cmd.auth(proc,uin, "game")) return;
try{
int stavka = (Integer)v.get(0);
int naperstok_s = (Integer)v.get(1);
Users uss = cmd.srv.us.getUser(uin);
if(uss.room!=cmd.psp.getIntProperty("games.naperstokroom")){
proc.mq.add(uin,"       "+cmd.psp.getIntProperty("games.naperstokroom")+" ");
return;
}
if (uss.ball < stavka){
proc.mq.add(uin,"    .");
return;
}
if (stavka < cmd.psp.getIntProperty("max.money.besproigrash")){
proc.mq.add(uin,"     "+cmd.psp.getIntProperty("max.money.besproigrash")+ " ");
return;
}
if (naperstok_s > 3){
proc.mq.add(uin,"     !");
return;
}
int naperstok = cmd.radm.getRND(3)+1;// 3 
proc.mq.add(uin,"  "+stavka+ "  "+naperstok_s+" .");
String s1="   ,    "+naperstok +"   ";// 
if(naperstok==naperstok_s){
uss.ball+=stavka;
s1+="\n  "+stavka+ " $!   "+uss.ball+"$";
}else{
uss.ball-=stavka;
s1+="\n  "+stavka+ " $!   "+uss.ball+"$";
}
cmd.srv.us.updateUser(uss);
proc.mq.add(uin,s1);
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}

/**
*  ...
*/
public void commandBesProigrishnaya(IcqProtocol proc, String uin){
if(!cmd.auth(proc,uin, "game")) return;
try{
Users uss = cmd.srv.us.getUser(uin);
if(uss.room!=cmd.psp.getIntProperty("games.besproigrishroom")){
proc.mq.add(uin,"       "+cmd.psp.getIntProperty("games.besproigrishroom")+" ");
return;
}
if (uss.ball < 10){
proc.mq.add(uin,"    .");
return;
}

int priz = cmd.radm.getRND(20)+1;
uss.ball+=priz-10;
proc.mq.add(uin,"  "+ priz+ "$.    10 $.   "+uss.ball+" $");
cmd.srv.us.updateUser(uss);
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin," "+ex.getMessage());
}
}

/**
 * 
 * @param proc
 * @param uin
 * @param tmsg
 * @param v
 */
public void commandRum(IcqProtocol proc, String uin, String tmsg, Vector v){
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
if (!(cmd.psp.getBooleanProperty("chat.Rum"))) return;
try {
int i1 = ((Integer)v.get(0)).intValue();
int s = ((Integer)v.get(0)).intValue();
int num = (int)(Math.random() * 6.0D);
Users uss = cmd.srv.us.getUser(uin);
if (uss.room != cmd.psp.getIntProperty("room.rumushka")){
proc.mq.add(uin, "   " + cmd.psp.getIntProperty("room.rumushka") +" ");
return;
}
int moder_id = uss.id;
String r = "!";
if (s > 6) {
proc.mq.add(uin, ":     1  6");
return;
}
if (s < 1) {
proc.mq.add(uin, ":     1  6");
return;
}
cmd.srv.cq.addMsg(":   : " + num + " ,  " + uss.localnick + " : |" + s + "|", "", uss.room);
if (s == num){
cmd.srv.cq.addMsg(":  ! ! " + uss.id +  uss.localnick + "     !", "", uss.room);
proc.mq.add(uin, ":   : " + num + " ,    : " + s + " ,  ! !  !");
String nick = "[]";
uss.localnick = nick;
cmd.srv.us.updateUser(uss);
cmd.srv.us.db.event(uss.id, uin, "reg", 0, "", nick);
cmd.srv.us.revokeUser(i1, "reg");
} else{
proc.mq.add(uin, ": ,   ,   !");
}
} catch (Exception ex) {
ex.printStackTrace();
proc.mq.add(uin, " " + ex.getMessage());
}
}

/**
*   .
*/
   public void GamesWar(IcqProtocol proc, String uin, Vector v, String mmsg) {
class WarInfo {
boolean started = false;
int health; // 
int damage; // 
int prize;  //
String names;
boolean bot = false; // true,   ,  
}

String[] names = {"", "", "", ". ", "", ""}; //
int[] health   = {      100,       150,     200,       250,     300,          350}; //
int[] damage   = {       5,         30,       40,         55,       60,            70}; //
int[] prize    = {      500,       1500,     2500,       4000,     6000,          9000}; //
Users u = cmd.srv.us.getUser(uin);


if (!(cmd.psp.getBooleanProperty("chat.robo"))) {
 proc.mq.add(uin,"-   !");


    return;



}
if (u.room!=cmd.psp.getIntProperty("ring.room")) {
proc.mq.add(uin,":   "+cmd.psp.getIntProperty("ring.room")+"  - " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("ring.room")).getName());
return;
}

CommandExtend ucmd = games.get(uin);
if (ucmd==null) {

String list = ":   -:";
for (int i=0; i<names.length; i++)
list = list + "\n" + (i+1) + ") " + names[i] + " - [H-" + health[i] + "] (L-"+prize[i]+")";
list += "\n0)  ";
Vector v2=new Vector(1);
v2.add(new WarInfo());
ucmd = new CommandExtend(uin,mmsg,null,v2,300000);
games.put(uin, ucmd);
proc.mq.add(uin, list);
return;
}
Vector v2=ucmd.getData();
WarInfo info = (WarInfo)v2.get(0);

String[] places  = {"", "", ""};
String[] placesv = {"", "", ""};
String placesList = "";
for (int i = 0; i<places.length; i++) {
if (i!=0) placesList += ", ";
placesList += places[i];
}

if (!info.started) {
// 
int botIndex = -1;
try {
botIndex = Integer.parseInt(mmsg);
} catch (NumberFormatException ex) {
}
if (botIndex<0 || botIndex>names.length) {
ucmd = new CommandExtend(uin,ucmd.getCmd(),null,v2,300000);
games.put(uin, ucmd);
proc.mq.add(uin, ":     0  " + names.length + ".\n"
        + "  .");
return;
}
if (botIndex==0) {
games.remove(uin);
proc.mq.add(uin, ":   .");
return;
}
info.started = true;
botIndex--;
info.health = health[botIndex];
info.damage = damage[botIndex];
info.prize = prize[botIndex];
info.names = names[botIndex];
ucmd = new CommandExtend(uin,ucmd.getCmd(),null,v2,300000);
games.put(uin, ucmd);
proc.mq.add(uin, ":  : " + names[botIndex]+ ".\n"
        + " , ,    ("+placesList+").");
cmd.srv.cq.addMsg(":     " + names[botIndex] + "   " + u.localnick, u.sn, u.room);
return;
}
//
String strPlace = mmsg.trim().toLowerCase();
int userPlace = -1;
for (int i = 0; i<places.length; i++) {
if (strPlace.equals(places[i])) {
userPlace = i;
break;
}
}
if (userPlace<0) {
proc.mq.add(uin, ":       ("+placesList+")\n"
        + "  .");
games.put(uin, new CommandExtend(uin,ucmd.getCmd(),null,v2,300000));
return;
}
int botPlace = r.nextInt(places.length);
String msg;
if (info.bot) {
// 
if (userPlace==botPlace) {
msg = ": " + info.names + "     " + placesv[userPlace] + ",   .\n";
}
else {
int damage2 = (int)(info.damage*(r.nextDouble()/2+0.75));//- 25%

u.hp -= damage2;
if (u.hp<=0) {
u.hp = 0;

}
msg = ": "+info.names+"    " + placesv[botPlace] + ".    - " + damage2 + " %.  : " + u.hp + " %.\n";
cmd.srv.us.updateUser(u);
if (u.hp==0) {
msg += ":   -  .";
       
cmd.srv.cq.addMsg(":     "+info.names+" &&  " + u.localnick + " -  !!!", u.sn, u.room);
games.remove(uin);
proc.mq.add(uin, msg);
return;
}
}
}
else {
// 
if (userPlace==botPlace) {
msg = ": " + info.names + "    " + placesv[userPlace] + ",   .";
}
else {
int damage2 = (int) ((Math.random()*5));
if (damage2<1) damage2 = 5;
else if (damage2>100) damage2 = 100;
msg = ": " + info.names + "    " + placesv[botPlace] + ",  ! " + info.names + " [H-"+info.health+"]   - " + damage2 + " HP.\n";
info.health -= damage2;
if (info.health<=0) {
int prize2 = (int)(info.prize*(r.nextDouble()/2+0.75)); //- 25%
u.ball += prize2;
u.age+=5;
u.hp=u.age;
u.age+=1;
cmd.srv.us.updateUser(u);
msg += ":   -  !\n"
        + "  ("+prize2+") .  ! *YAHOO*";
cmd.srv.cq.addMsg(":     "+info.names+" &&  "+u.localnick +" -  !!!", u.sn, u.room);
games.remove(uin);
proc.mq.add(uin, msg);
return;
}
}
}
if (info.bot) {
info.bot = false;
msg += ":    - ,    (" + placesList + ").";
}
else {
info.bot = true;
msg += ":    - ,    (" + placesList + ").";
}
proc.mq.add(uin, msg);
games.put(uin, new CommandExtend(uin,ucmd.getCmd(),null,v2,300000));
}


/**
*    .
*/
public void GamesBattle(IcqProtocol proc, String uin, Vector v, String mmsg) {
class BattleInfo {
boolean started = false;
int[] id = new int[2];       //
int currentAttacker = 0;
int[] place = new int[2];
BattleInfo(int id0, int id1) {
id[0] = id0;
id[1] = id1;
place[0] = -1;
place[1] = -1;
}
}
if (v.size()>0) {
// 
Users target = cmd.srv.us.getUser((Integer)v.get(0));
Users sender = cmd.srv.us.getUser(uin);
if(sender.room!=cmd.psp.getIntProperty("ring.room"))
{
proc.mq.add(uin,":    " +cmd.psp.getIntProperty("ring.room")+ "  - " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("ring.room")).getName());
return;
}
if(target.room!=sender.room) {
proc.mq.add(uin,":          .");
return;
}
if (target.state==UserWork.STATE_NO_REG) {
proc.mq.add(uin,":    ID  .");
return;
}
if (target.state!=UserWork.STATE_CHAT) {
proc.mq.add(uin,":      .");
return;
}
if (sender.id==target.id) {
proc.mq.add(uin,":      .");
return;
}
CommandExtend ucmd = games.get(target.sn);
if (ucmd!=null && !ucmd.isExpire()) {
proc.mq.add(uin,":      ,   .");
return;
}
Vector v2=new Vector(2);
v2.add(0);
v2.add(new BattleInfo(sender.id, target.id));
ucmd = new CommandExtend(target.sn,mmsg,null,v2,300000);
games.put(target.sn, ucmd);
cmd.srv.getIcqProcess(target.basesn).mq.add(target.sn, ":  "+sender.localnick+" ["+sender.id+"] ()   !  \"\",   .      ,  \"\".");
proc.mq.add(uin, ":       "+target.localnick+" ["+target.id+"].");
return;
}
CommandExtend ucmd = games.get(uin);
if (ucmd==null) {
proc.mq.add(uin, ":   .");
return;
}
Vector v2=ucmd.getData();
BattleInfo info = (BattleInfo)v2.get(1);
String[] places  = {"", "", ""};
String[] placesv = {"", "", ""};
String placesList = "";
for (int i = 0; i<places.length; i++) {
if (i!=0) placesList += ", ";
placesList += places[i];
}
if (!info.started) { //   
String answer = mmsg.toLowerCase();
if (answer.equals("") || answer.equals("no")) {
games.remove(uin);
proc.mq.add(uin, ":    .");
Users sender=cmd.srv.us.getUser(info.id[0]);     //,   
Users target=cmd.srv.us.getUser(uin);          //,   
if (sender.state==UserWork.STATE_CHAT) {
cmd.srv.getIcqProcess(sender.basesn).mq.add(sender.sn, " "+target.localnick+" ["+target.id+"]   .");
}
return;
}
if (answer.equals("") || answer.equals("yes")) {
Users sender=cmd.srv.us.getUser(info.id[0]);     //,   
if (sender.state!=UserWork.STATE_CHAT) {
games.remove(uin);
proc.mq.add(uin, ":   ,  "+sender.localnick+" ["+sender.id+"]   .");
return;
}
if (games.containsKey(sender.sn)) {
games.remove(uin);
proc.mq.add(uin, ":  "+sender.localnick+" ["+sender.id+"]    .     () .   ()       .");
Users target=cmd.srv.us.getUser(uin);                //,   
cmd.srv.getIcqProcess(sender.basesn).mq.add(sender.sn, " "+target.localnick+" ["+target.id+"]       ,      .   ,        .");
return;
}
Users target=cmd.srv.us.getUser(uin);                    //,   
proc.mq.add(uin, ":       "+sender.localnick+" ["+sender.id+"]! ,    ("+placesList+").");
cmd.srv.getIcqProcess(sender.basesn).mq.add(sender.sn, ":  "+target.localnick+" ["+target.id+"]     !   , ,    ("+placesList+").");
info.started = true;
games.put(sender.sn, new CommandExtend(sender.sn,ucmd.getCmd(),null,v2,300000));
Vector v3=(Vector)v2.clone();
v3.set(0, 1);
games.put(uin, new CommandExtend(uin,ucmd.getCmd(),null,v3,300000));
return;
}
proc.mq.add(uin, ":   \"\"  \"\".   .");
games.put(uin, new CommandExtend(uin,ucmd.getCmd(),null,v2,300000));
return;
}
// 
int userIndex = (Integer)v2.get(0);
if (info.place[userIndex]>=0) {
proc.mq.add(uin, ":   .");
return;
}

String strPlace = mmsg.trim().toLowerCase();
int intPlace = -1;
for (int i = 0; i<places.length; i++) {
if (strPlace.equals(places[i])) {
intPlace = i;
break;
}
}
if (intPlace<0) {
proc.mq.add(uin, ":       ("+placesList+").   .");
games.put(uin, new CommandExtend(uin,ucmd.getCmd(),null,v2,300000));
return;
}
info.place[userIndex] = intPlace;
if (info.place[1-userIndex]==-1) {
proc.mq.add(uin, ":   ,   .");
games.put(uin, new CommandExtend(uin,ucmd.getCmd(),null,v2,300000));
return;
}
Users attacker=cmd.srv.us.getUser(info.id[info.currentAttacker]); //,   
Users target=cmd.srv.us.getUser(info.id[1-info.currentAttacker]); //,   
int attPlace = info.place[info.currentAttacker];
int defPlace = info.place[1-info.currentAttacker];
//   
info.currentAttacker = 1 - info.currentAttacker;
info.place[0] = -1;
info.place[1] = -1;

String attmsg, defmsg;
if (attPlace == defPlace) {
attmsg = ":     " + placesv[attPlace] + ",   .\r\n";
defmsg = ":      " + placesv[attPlace] + ",   .\r\n";
}
else {
int damage = 50 + r.nextInt(30);
target.hp -= damage;
if (target.hp<0) target.hp = 0;
attmsg = ":     " + placesv[defPlace] + ",  !    " + damage + "%.\r\n";
defmsg = ":     " + placesv[attPlace] + ".    " + damage + "%.  : " + target.hp + "%.\r\n";
cmd.srv.us.updateUser(target);
if (target.hp==0) {
attacker.ball += 500;
attacker.age += 5;
attacker.age+=1;
attacker.hp=attacker.age;
cmd.srv.us.updateUser(attacker);
cmd.srv.getIcqProcess(attacker.basesn).mq.add(attacker.sn, attmsg + "  -  !   (100) .");
cmd.srv.getIcqProcess(target.basesn).mq.add(target.sn, defmsg + "  -  .");
games.remove(attacker.sn);
games.remove(target.sn);
return;
}
else cmd.srv.us.updateUser(attacker);
}
cmd.srv.getIcqProcess(attacker.basesn).mq.add(attacker.sn, attmsg + "   - ,    (" + placesList + ").");
cmd.srv.getIcqProcess(target.basesn).mq.add(target.sn, defmsg + "   - ,    (" + placesList + ").");
games.put(uin, new CommandExtend(uin,ucmd.getCmd(),null,v2,300000));
}








public void commandStr(IcqProtocol proc, String uin, String tmsg, Vector v) {
if ((!(cmd.isChat(proc, uin))) && (!(cmd.psp.testAdmin(uin)))) return;
if (!(cmd.auth(proc, uin, "game"))) return;
try {
int g = (int)(Math.random() * 5.0);
int i = ((Integer)v.get(0)).intValue();
Users u = cmd.srv.us.getUser(i);
Users us = cmd.srv.us.getUser(uin);

///////////////////////////////
if (cmd.psp.getBooleanProperty("room_str.on.off")){
if (us.room != cmd.psp.getIntProperty("room.str")){
proc.mq.add(uin, "    " + cmd.psp.getIntProperty("room.str") + "  " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("room.str")).getName() + "");
return;
}
}


if (cmd.psp.getBooleanProperty("room_str.no.off")){
if (us.room == cmd.psp.getIntProperty("room.no.str")){
proc.mq.add(uin, "   " + cmd.psp.getIntProperty("room.no.str") + "  " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("room.no.str")).getName() + "");
return;
}
}
if (cmd.psp.getBooleanProperty("imm.on.off")){
if (u.number == 1){
proc.mq.add(uin, cmd.radm.NICK()+": "+ u.localnick+"  .    !!");
proc.mq.add(u.sn, us.localnick + ", " + "()       .");
return;
    }
}


///////////////////////////////
if (u.id == 0) {
proc.mq.add(uin, "  ");
return;
}
if (u.state == 1) {
proc.mq.add(uin, "   ");
return;
}

if (us.room != u.room) {
proc.mq.add(uin, "   ");
return;
}
if (u.ball < 20) {
proc.mq.add(uin, "   ,    ?!");
return;
}

if (cmd.psp.getBooleanProperty("war.clan.on.off")){
if(us.clansman == u.clansman && us.clansman!=0 && u.clansman!=0)
{
proc.mq.add( uin, us.localnick + "        ." );
return;
}
    }

if (cmd.psp.getBooleanProperty("immm.on.off")){

if (u.holodnoe == 0 && u.orujie == 0) {
proc.mq.add(uin,"  ,   !");
return;
}
    }

if (us.birthyear <= 0) {
proc.mq.add(uin, "   ");
return;
}

if (us.orujie == 0) {
proc.mq.add(uin, "  ?   !");
return;
}
if (us.id == u.id) {
proc.mq.add(uin, "  ?");
return;
}

if (us.age < u.age) {
proc.mq.add(uin, "      .");
return;
}

int op;
int gold;
int gold2;
int gold3;
int stv = us.orujie;
if (us.birthyear > 0) {

int bronya;
int hp;

if (us.orujie>0) {
op = us.age + g;
us.age = op;


//hp -  ,      
if (u.bronya >= ShootingProp.getInstance(cmd.srv.getName()).getArmour(stv)){
bronya = u.bronya - ShootingProp.getInstance(cmd.srv.getName()).getArmour(stv);
u.bronya = bronya;
gold = u.ball - ShootingProp.getInstance(cmd.srv.getName()).getPurse(stv);
u.ball = gold;
gold2 = us.ball + ShootingProp.getInstance(cmd.srv.getName()).getReward(stv);
us.ball = gold2;
gold3 = us.birthyear - 1;
us.birthyear = gold3;
cmd.srv.us.updateUser(u);
cmd.srv.us.updateUser(us);
proc.mq.add(uin, "   " + u.localnick + "  "+ShootingProp.getInstance(cmd.srv.getName()).getName(stv)+".     "+ ShootingProp.getInstance(cmd.srv.getName()).getReward(stv)+ " " + cmd.psp.getStringProperty("valuta.chat") + " ,    "+ShootingProp.getInstance(cmd.srv.getName()).getArmour(stv)+"    "+ShootingProp.getInstance(cmd.srv.getName()).getPurse(stv)+ " " + cmd.psp.getStringProperty("valuta.chat"));
cmd.srv.getIcqProcess(u.basesn).mq.add(u.sn, u.localnick + ", " + "    "+ShootingProp.getInstance(cmd.srv.getName()).getName(stv)+" " + us.localnick + "   "+ShootingProp.getInstance(cmd.srv.getName()).getArmour(stv)+"   "+ShootingProp.getInstance(cmd.srv.getName()).getPurse(stv)+ " " + cmd.psp.getStringProperty("valuta.chat"));

} else if (u.hp >= ShootingProp.getInstance(cmd.srv.getName()).getHealth(stv)){
hp = u.hp - ShootingProp.getInstance(cmd.srv.getName()).getHealth(stv);
u.hp = hp;
gold = u.ball - ShootingProp.getInstance(cmd.srv.getName()).getPurse(stv);
u.ball = gold;
gold2 = us.ball + ShootingProp.getInstance(cmd.srv.getName()).getReward(stv);
us.ball = gold2;
gold3 = us.birthyear - 1;
us.birthyear = gold3;
cmd.srv.us.updateUser(u);
cmd.srv.us.updateUser(us);
proc.mq.add(uin, "   " + u.localnick + "  "+ShootingProp.getInstance(cmd.srv.getName()).getName(stv)+".     "+ ShootingProp.getInstance(cmd.srv.getName()).getReward(stv)+ " " + cmd.psp.getStringProperty("valuta.chat") + " ,    "+ShootingProp.getInstance(cmd.srv.getName()).getHealth(stv)+"   "+ShootingProp.getInstance(cmd.srv.getName()).getPurse(stv)+ " " + cmd.psp.getStringProperty("valuta.chat"));
cmd.srv.getIcqProcess(u.basesn).mq.add(u.sn, u.localnick + ", " + "    "+ShootingProp.getInstance(cmd.srv.getName()).getName(stv)+" " + us.localnick + "   "+ShootingProp.getInstance(cmd.srv.getName()).getHealth(stv)+"   "+ShootingProp.getInstance(cmd.srv.getName()).getPurse(stv)+ " " + cmd.psp.getStringProperty("valuta.chat"));
}











if(u.hp < ShootingProp.getInstance(cmd.srv.getName()).getHealth(stv)) {
if (cmd.psp.getBooleanProperty("hospital.on.off")){
int goldhelp = u.hp+cmd.psp.getIntProperty("hospital.zdorove");
u.hp=goldhelp;
//cmd.radm.say(u.localnick + "       " + cmd.psp.getIntProperty("time.help") + " ", u.sn);
u.room = cmd.psp.getIntProperty("room.hospital");
cmd.radm.srv.cq.changeUserRoom(u.sn, cmd.psp.getIntProperty("room.hospital"));
cmd.radm.say("  , : " + u.localnick, cmd.psp.getIntProperty("room.hospital"));
cmd.radm.srv.us.revokeUser(u.id, "room");
u.lastclosed = System.currentTimeMillis() + cmd.psp.getIntProperty("time.help") * 60000;
cmd.radm.srv.us.updateUser(u);
cmd.radm.srv.getIcqProcess(u.basesn).mq.add(u.sn,"!!!  ! "+u.localnick + "       " + cmd.psp.getIntProperty("time.help") + " ");
 proc.mq.add(uin, "   " + u.localnick + ".     ()  ");
}
}

return;
}

}
}catch (Exception ex) {
ex.printStackTrace();
  proc.mq.add(uin, "   .    !!!");
}

}

}