/**
 * JimBot - Java IM Bot
 * Copyright (C) 2010 JimBot project
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package ru.jimbot.modules.chat;

import java.util.Vector;
import java.util.HashMap;
//import ru.jimbot.Manager;
import ru.jimbot.Manager;
import ru.jimbot.modules.Cmd;
import ru.jimbot.protocol.IcqProtocol;
import ru.jimbot.modules.CommandParser;
import ru.jimbot.modules.CommandExtend;

import ru.jimbot.util.BarProps;
import ru.jimbot.util.OtherProp;
import ru.jimbot.util.PlainProp;
import ru.jimbot.util.ShootingProp;
//import ru.jimbot.util.MainProps;



public class inShop {
private HashMap<String, Cmd> commands = new HashMap<String, Cmd>();
private CommandParser parser;
private ChatCommandProc cmd;
private HashMap<String, CommandExtend> inShopMap;
public ChatServer srv;
  /**Creates a new instance of Help*/
public inShop(ChatCommandProc c) {
parser = new CommandParser(commands);
cmd = c;
inShopMap = new HashMap<String, CommandExtend>();
init();
}

private void init() {
commands.put("!", new Cmd("!", "", 1));
commands.put("!", new Cmd("!", "", 1));
commands.put("!", new Cmd("!", "", 1));
commands.put("!", new Cmd("!", "", 2));
commands.put("!", new Cmd("!", "", 2));
commands.put("!", new Cmd("!", "", 3));
commands.put("!", new Cmd("!", "", 3));
commands.put("!", new Cmd("!", "", 4));
commands.put("!", new Cmd("!", "", 5));

commands.put("!", new Cmd("!", "", 6));
commands.put("!", new Cmd("!", "", 6));
commands.put("!", new Cmd("!", "", 7));



}
public boolean addCommand(String name, Cmd c) {
boolean f = commands.containsKey(name);
commands.put(name, c);
return f;
}
public boolean commandinShop(IcqProtocol proc, String uin, String mmsg) {
String tmsg = mmsg.trim();
int tp = 0;
if(inShopMap.containsKey(uin))
if(!inShopMap.get(uin).isExpire())
tp = parser.parseCommand(inShopMap.get(uin).getCmd());
else {
tp = parser.parseCommand(tmsg);
inShopMap.remove(uin);
}else
tp = parser.parseCommand(tmsg);

int tst=0;
if(tp<0)
tst = 0;
else
tst = tp;
boolean f = true;
switch (tst) {
case 1:
cinShop(proc, uin, mmsg);
break;
case 2:
HinShop(proc, uin, mmsg);
break;
case 3:
ArmourShop(proc, uin, mmsg);
break;
case 4:
PravaShop(proc, uin, mmsg);
break;
case 5:
BarShop(proc, uin, mmsg);
break;

case 6:
Pricols(proc, uin, mmsg);
break;
case 7:
Menu(proc, uin, mmsg);
break;



default:
f = false;
break;
}
return f;
}
public void cinShop(IcqProtocol proc, String uin, String mmsg){
try{
Users uss = cmd.srv.us.getUser(uin);
if ((uss.room != cmd.psp.getIntProperty("orugie.room"))){
proc.mq.add(uin, "     [" + cmd.psp.getIntProperty("orugie.room") + "] " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("orugie.room")).getName() + "" );
return;
}
String list = " :\n  \n    :\n";
int step = 0; //
String cm = ""; //
Vector v1 = new Vector(); // 
if (inShopMap.containsKey(uin)){
step = Integer.parseInt(inShopMap.get(uin).getMsg()); //      
cm = inShopMap.get(uin).getCmd(); // ,     .. 
v1 = inShopMap.get(uin).getData();
}
switch (step){
case 0: //  
for(int i=1;i<ShootingProp.getInstance(cmd.srv.getName()).weaponCount();i++){
list += i+"  "+ShootingProp.getInstance(cmd.srv.getName()).getName(i)+"  "+ShootingProp.getInstance(cmd.srv.getName()).getPrice(i)+"\n";
}
proc.mq.add(uin,list+"   [0]");
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,60000));
break;
case 1: //  
for(int i1=1;i1<ShootingProp.getInstance(cmd.srv.getName()).weaponCount();i1++){
if(mmsg.equals(Integer.toString(i1))){
if (uss.ball < ShootingProp.getInstance(cmd.srv.getName()).getPrice(i1)){
proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
return;
}
int uroven5 = uss.orujie = Integer.parseInt(mmsg);
uss.orujie = uroven5;
int gold = uss.ball - ShootingProp.getInstance(cmd.srv.getName()).getPrice(i1);
uss.ball = gold;
int uroven = uss.age + ShootingProp.getInstance(cmd.srv.getName()).getCriminality(i1);
uss.age = uroven;
String gold3 = uss.pushka = ShootingProp.getInstance(cmd.srv.getName()).getName(i1);
uss.pushka = gold3;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin, "  ,     "+ShootingProp.getInstance(cmd.srv.getName()).getName(i1)+"..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+ShootingProp.getInstance(cmd.srv.getName()).getCriminality(i1));
cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   "+ShootingProp.getInstance(cmd.srv.getName()).getName(i1)+"", uss.sn, uss.room);
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
return;
}
}
if(mmsg.trim().equals("0")){
proc.mq.add(uin, "   !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
        return;
}
proc.mq.add(uin, "    . .    !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
break;
  }
}catch(Exception ex){
ex.printStackTrace();
proc.mq.add(uin,"Error: "+ex.getMessage());
}
}

public void HinShop(IcqProtocol proc, String uin, String mmsg){
try{
Users uss = cmd.srv.us.getUser(uin);
if ((uss.room != cmd.psp.getIntProperty("orugie.room"))){
proc.mq.add(uin, "     [" + cmd.psp.getIntProperty("orugie.room") + "] " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("orugie.room")).getName() + "" );
return;
}
String list = " :\n  \n    :\n";
int step = 0; //
String cm = ""; //
Vector v1 = new Vector(); // 
if (inShopMap.containsKey(uin)){
step = Integer.parseInt(inShopMap.get(uin).getMsg()); //      
cm = inShopMap.get(uin).getCmd(); // ,     .. 
v1 = inShopMap.get(uin).getData();
}
switch (step){
case 0: //  
for(int i=1;i<PlainProp.getInstance(cmd.srv.getName()).weaponCount();i++){
list += i+"  "+PlainProp.getInstance(cmd.srv.getName()).getName(i)+"  "+PlainProp.getInstance(cmd.srv.getName()).getPrice(i)+"\n";
}
proc.mq.add(uin,list+"   [0]");
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,60000));
break;
case 1: //  
for(int i1=1;i1<PlainProp.getInstance(cmd.srv.getName()).weaponCount();i1++){
if(mmsg.equals(Integer.toString(i1))){
if (uss.ball < PlainProp.getInstance(cmd.srv.getName()).getPrice(i1)){
proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
return;
}
int uroven5 = uss.holodnoe = Integer.parseInt(mmsg);
uss.holodnoe = uroven5;
int gold = uss.ball - PlainProp.getInstance(cmd.srv.getName()).getPrice(i1);
uss.ball = gold;
int uroven = uss.age + PlainProp.getInstance(cmd.srv.getName()).getCriminality(i1);
uss.age = uroven;
String gold3 = uss.hold_org = PlainProp.getInstance(cmd.srv.getName()).getName(i1);
uss.hold_org = gold3;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin, "  ,     "+PlainProp.getInstance(cmd.srv.getName()).getName(i1)+"..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+PlainProp.getInstance(cmd.srv.getName()).getCriminality(i1));
cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()   "+PlainProp.getInstance(cmd.srv.getName()).getName(i1)+"", uss.sn, uss.room);
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
return;
}
}
if(mmsg.trim().equals("0")){
proc.mq.add(uin, "   !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
        return;
}
proc.mq.add(uin, "    . .    !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
break;
  }
}catch(Exception ex){
ex.printStackTrace();
proc.mq.add(uin,"Error: "+ex.getMessage());
}
}


public void ArmourShop(IcqProtocol proc, String uin, String mmsg){
try{
Users uss = cmd.srv.us.getUser(uin);
if ((uss.room != cmd.psp.getIntProperty("orugie.room"))){
proc.mq.add(uin, "     [" + cmd.psp.getIntProperty("orugie.room") + "] " + cmd.srv.us.getRoom(cmd.psp.getIntProperty("orugie.room")).getName() + "" );
return;
}
String list = " :\n  \n    :\n";
int step = 0; //
String cm = ""; //
Vector v1 = new Vector(); // 
if (inShopMap.containsKey(uin)){
step = Integer.parseInt(inShopMap.get(uin).getMsg()); //      
cm = inShopMap.get(uin).getCmd(); // ,     .. 
v1 = inShopMap.get(uin).getData();
}
switch (step){
case 0: //  
for(int i=1;i<OtherProp.getInstance(cmd.srv.getName()).weaponCount();i++){
list += i+"  "+OtherProp.getInstance(cmd.srv.getName()).getName(i)+"  "+OtherProp.getInstance(cmd.srv.getName()).getPrice(i)+"\n";
}
proc.mq.add(uin,list+"   [0]");
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,60000));
break;
case 1: //  
for(int i1=1;i1<OtherProp.getInstance(cmd.srv.getName()).weaponCount();i1++){
if(mmsg.equals(Integer.toString(i1))){
if (uss.ball < OtherProp.getInstance(cmd.srv.getName()).getPrice(i1)){
proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
return;
}
//int uroven5 = uss.holodnoe = Integer.parseInt(mmsg);
//uss.holodnoe = uroven5;
int gold = uss.ball - OtherProp.getInstance(cmd.srv.getName()).getPrice(i1);
uss.ball = gold;
int uroven = uss.bronya + OtherProp.getInstance(cmd.srv.getName()).getHealth(i1);
uss.bronya = uroven;
String gold3 = uss.bronya_ = OtherProp.getInstance(cmd.srv.getName()).getName(i1);
uss.bronya_ = gold3;
cmd.srv.us.updateUser(uss);
proc.mq.add(uin, "  ,   "+OtherProp.getInstance(cmd.srv.getName()).getName(i1)+"..  : " + uss.ball + " " + cmd.psp.getStringProperty("valuta.chat")+".     "+OtherProp.getInstance(cmd.srv.getName()).getHealth(i1));
cmd.srv.cq.addMsg("[" + uss.id + "] " + uss.localnick + " ()  "+OtherProp.getInstance(cmd.srv.getName()).getName(i1)+"", uss.sn, uss.room);
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
return;
}
}
if(mmsg.trim().equals("0")){
proc.mq.add(uin, "   !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
        return;
}
proc.mq.add(uin, "    . .    !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
break;
  }
}catch(Exception ex){
ex.printStackTrace();
proc.mq.add(uin,"Error: "+ex.getMessage());
}
}


public void PravaShop(IcqProtocol proc, String uin, String mmsg){
try{
Users uss = cmd.srv.us.getUser(uin);
 if (!Manager.getInstance().getService(cmd.srv.getName()).getProps().getBooleanProperty("magprav.on.off")) {
    proc.mq.add(uin, "   ...");
    return;
    }

String list = "   :\n  \n     :\n";
int step = 0; //
String cm = ""; //
Vector v1 = new Vector(); // 
if (inShopMap.containsKey(uin)){
step = Integer.parseInt(inShopMap.get(uin).getMsg()); //      
cm = inShopMap.get(uin).getCmd(); // ,     .. 
v1 = inShopMap.get(uin).getData();
}
switch (step){
case 0: //  

for(int i=1;i<OtherProp.getInstance(cmd.srv.getName()).pravaCount();i++){
list += i+"  "+OtherProp.getInstance(cmd.srv.getName()).getPravaName(i)+"  "+OtherProp.getInstance(cmd.srv.getName()).getPravaPravo(i)+"  "+OtherProp.getInstance(cmd.srv.getName()).getPravaPrice(i)+"\n";
}
proc.mq.add(uin,list+"   [0]");
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,60000));
break;
case 1: //  
for(int i1=1;i1<OtherProp.getInstance(cmd.srv.getName()).pravaCount();i1++){
if(mmsg.equals(Integer.toString(i1))){
if (uss.ball < OtherProp.getInstance(cmd.srv.getName()).getPravaPrice(i1)){
proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
return;
}
//int uroven5 = uss.holodnoe = Integer.parseInt(mmsg);
//uss.holodnoe = uroven5;
 String[] gr = Manager.getInstance().getService(cmd.srv.getName()).getProps().getStringProperty("auth.groups").split(";");
for(int i3=0; i3<gr.length; i3++){


if(OtherProp.getInstance(cmd.srv.getName()).getPravaPravo(i1).equals(gr[i3])){
cmd.srv.us.getUser(uss.id).group = OtherProp.getInstance(cmd.srv.getName()).getPravaPravo(i1);
boolean f = cmd.srv.us.setUserPropsValue(uss.id, "group", OtherProp.getInstance(cmd.srv.getName()).getPravaPravo(i1)) &&
cmd.srv.us.setUserPropsValue(uss.id, "grant", "") &&
cmd.srv.us.setUserPropsValue(uss.id, "revoke", "");
cmd.srv.us.clearCashAuth(uss.id);
int reiting = uss.ball-OtherProp.getInstance(cmd.srv.getName()).getPravaPrice(i1);
uss.ball=reiting;
cmd.srv.us.updateUser(uss);
//proc.mq.add(uin,uss.localnick+"     "+OtherProp.getInstance(cmd.srv.getName()).getPravaPravo(i1));
//cmd.srv.cq.addMsg(" " + uss.localnick + "[" + uss.id + "],   ["+ cmd.srv.us.getUserGroup(uss.id) + "]", "", uss.room);
 }else{
   for (String c : cmd.authObj.keySet()) {

  if(OtherProp.getInstance(cmd.srv.getName()).getPravaPravo(i1).equals(c)){
           cmd.srv.us.grantUser(uss.id, OtherProp.getInstance(cmd.srv.getName()).getPravaPravo(i1));
int reiting = uss.ball-OtherProp.getInstance(cmd.srv.getName()).getPravaPrice(i1);
uss.ball=reiting;
cmd.srv.us.updateUser(uss);
        }

 }
  
    }








}
  proc.mq.add(uin,"   "+OtherProp.getInstance(cmd.srv.getName()).getPravaPravo(i1));
cmd.srv.cq.addMsg(" " + uss.localnick + "[" + uss.id + "],   "+OtherProp.getInstance(cmd.srv.getName()).getPravaPravo(i1),"", uss.room);

 inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
return;
    }
}
if(mmsg.trim().equals("0")){
proc.mq.add(uin, "      !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
        return;
}
proc.mq.add(uin, "    . .    !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
break;
  }
}catch(Exception ex){
ex.printStackTrace();
proc.mq.add(uin,"Error: "+ex.getMessage());
}
}



/**
 *  
 * @param proc
 * @param uin
 * @param mmsg
 */
public void BarShop(IcqProtocol proc, String uin, String mmsg){
try{
Users uss = cmd.srv.us.getUser(uin);
String list = ":-):\n    :\n  \n    :\n";
int step = 0; //
String cm = ""; //
Vector v1 = new Vector(); // 
if (inShopMap.containsKey(uin)){
step = Integer.parseInt(inShopMap.get(uin).getMsg()); //      
cm = inShopMap.get(uin).getCmd(); // ,     .. 
v1 = inShopMap.get(uin).getData();
}
switch (step){
case 0: //  
for(int i=1;i<BarProps.getInstance(cmd.srv.getName()).barCount();i++){
list += i+"  "+BarProps.getInstance(cmd.srv.getName()).getName(i)+"  "+BarProps.getInstance(cmd.srv.getName()).getPrice(i)+"\n";
}
proc.mq.add(uin,list+"   [0]");
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,60000));
break;
case 1: //  
for(int i1=1;i1<BarProps.getInstance(cmd.srv.getName()).barCount();i1++){
if(mmsg.equals(Integer.toString(i1))){
if (uss.ball < BarProps.getInstance(cmd.srv.getName()).getPrice(i1)){
proc.mq.add(uin, " : " + uss.ball+ " " + cmd.psp.getStringProperty("valuta.chat")+ " ,      .");
return;
}
if(uss.alcohol>cmd.psp.getIntProperty("max.alc")){
proc.mq.add(uin," ... : !");
}
uss.bar = BarProps.getInstance(cmd.srv.getName()).getName(i1);
int gold = uss.ball - BarProps.getInstance(cmd.srv.getName()).getPrice(i1);
uss.ball = gold;
int al=uss.alcohol + BarProps.getInstance(cmd.srv.getName()).getIntoxication(i1);
uss.alcohol = al;

if(uss.hp<=100){
int hp=uss.hp +  BarProps.getInstance(cmd.srv.getName()).getIntoxication(i1);
uss.hp = hp;
}
cmd.srv.us.updateUser(uss);
cmd.srv.cq.addMsg("  "+uss.localnick+" ()     "+BarProps.getInstance(cmd.srv.getName()).getName(i1)+".    "+uss.localnick+"       "+BarProps.getInstance(cmd.srv.getName()).getIntoxication(i1)+"% ", uss.sn, uss.room);
proc.mq.add(uin,"  "+BarProps.getInstance(cmd.srv.getName()).getName(i1)+"    "+BarProps.getInstance(cmd.srv.getName()).getIntoxication(i1)+"%, +      "+BarProps.getInstance(cmd.srv.getName()).getIntoxication(i1)+"%.   "+ BarProps.getInstance(cmd.srv.getName()).getPrice(i1)+ " " + cmd.psp.getStringProperty("valuta.chat"));
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
return;
}
}
if(mmsg.trim().equals("0")){
proc.mq.add(uin, "    !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
return;
}
proc.mq.add(uin, "    . .    !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
break;
}
}catch(Exception ex){
ex.printStackTrace();
proc.mq.add(uin,"Error: "+ex.getMessage());
}
}



public void Pricols(IcqProtocol proc, String uin, String mmsg){
try{
int step = 0; //
String cmd2 = ""; //
Vector v1 = new Vector(); // 
if (inShopMap.containsKey(uin)){
step = Integer.parseInt(inShopMap.get(uin).getMsg()); //      
cmd2 = inShopMap.get(uin).getCmd(); // ,     .. 
v1 = inShopMap.get(uin).getData();
}


switch (step){
//


case 0:
String list = "  :\n  :\n";
for(int i=1;i<OtherProp.getInstance(cmd.srv.getName()).laidCount();i++){
list += i+"  "+OtherProp.getInstance(cmd.srv.getName()).getLaidName(i)+"\n";
}

proc.mq.add(uin,list+"   [0]");
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,60000));
break;

case 1:
    try{
Integer.parseInt(mmsg);
}catch(NumberFormatException e){
proc.mq.add(uin, "  \n   [0]");

return;
}
    
if(Integer.parseInt(mmsg) > (OtherProp.getInstance(cmd.srv.getName()).laidCount()-1) || Integer.parseInt(mmsg)<=0 ){

proc.mq.add(uin, "    !   ,   !");
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,10));
return;
    }







v1.add(0,mmsg);
proc.mq.add(uin, "  ");
inShopMap.put(uin, new CommandExtend(uin,cmd2,"2",v1,60000));
break;
   
case 2:
if (!mmsg.trim().equals(" ")){
v1.add(1,mmsg);

   try{
Integer.parseInt(mmsg);
}catch(NumberFormatException e){
proc.mq.add(uin, "  \n   [0]");
return;
}

String id_ =(String)v1.get(0);
int id = Integer.parseInt(id_);
String um_ =(String)v1.get(1);
int um = Integer.parseInt(um_);
Users us = cmd.srv.us.getUser(uin);
Users u = cmd.srv.us.getUser(um);
 
if (Integer.parseInt(mmsg)==0){
proc.mq.add(uin, "    !   ,   !");
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,10));
return;
}
if (u.state!=UserWork.STATE_CHAT){
proc.mq.add(uin," " + u.localnick + "   !");
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,10));
return;
}
String one = OtherProp.getInstance(cmd.srv.getName()).getLaidGeneral(id);
one = one.replace("#NIK#", u.localnick);
one = one.replace("#ID#", Integer.toString(u.id));
one = one.replace("#NIKS#", us.localnick);
one = one.replace("#IDS#", Integer.toString(us.id));
String two = OtherProp.getInstance(cmd.srv.getName()).getLaidPersonal(id);
two = two.replace("#NIK#", u.localnick);
two = two.replace("#ID#", Integer.toString(u.id));
two = two.replace("#NIKS#", us.localnick);
two = two.replace("#IDS#", Integer.toString(us.id));
String three =OtherProp.getInstance(cmd.srv.getName()).getLaidAnswer(id);
three = three.replace("#NIK#", u.localnick);
three = three.replace("#ID#", Integer.toString(u.id));
three = three.replace("#NIKS#", us.localnick);
three = three.replace("#IDS#", Integer.toString(us.id));


cmd.srv.cq.addMsg(one, u.sn, u.room);
cmd.srv.getIcqProcess(u.basesn).mq.add(u.sn,two);
proc.mq.add(uin,three);
int country = u.country;
u.country=country+1;
cmd.srv.us.updateUser(u);
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,10));
}else{
proc.mq.add(uin, "    .   .   1 .");
inShopMap.put(uin, new CommandExtend(uin,cmd2,"2",v1,120000));
}
break;
}
}catch(Exception ex){
ex.printStackTrace();
proc.mq.add(uin,"Error: "+ex.getMessage());
}
}



public void Menu(IcqProtocol proc, String uin, String mmsg){
try{
Users uss = cmd.srv.us.getUser(uin);
String list = " :\n  :\n";
int step = 0; //
String cm = ""; //
Vector v1 = new Vector(); // 
if (inShopMap.containsKey(uin)){
step = Integer.parseInt(inShopMap.get(uin).getMsg()); //      
cm = inShopMap.get(uin).getCmd(); // ,     .. 
v1 = inShopMap.get(uin).getData();
}
switch (step){
case 0: //  
for(int i=1;i<OtherProp.getInstance(cmd.srv.getName()).robCount();i++){
list += i+"  "+OtherProp.getInstance(cmd.srv.getName()).getRobName(i)+"\n";
}
proc.mq.add(uin,list+"   [0]");
inShopMap.put(uin, new CommandExtend(uin,mmsg,"1",v1,60000));
break;
case 1: //  
for(int i1=1;i1<OtherProp.getInstance(cmd.srv.getName()).robCount();i1++){
if(mmsg.equals(Integer.toString(i1))){

cmd.srv.getIcqProcess(uss.basesn).mq.add(uss.sn,OtherProp.getInstance(cmd.srv.getName()).getRobOtv(i1));
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
return;
}
}
if(mmsg.trim().equals("0")){
proc.mq.add(uin, "   !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
return;
}
proc.mq.add(uin, "    . .    !");
inShopMap.put(uin, new CommandExtend(uin,cm,"1",v1,10));
break;
}
}catch(Exception ex){
ex.printStackTrace();
proc.mq.add(uin,"Error: "+ex.getMessage());
}
}








}

