/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ru.jimbot.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;

/**
 *       
 * @author Prolubnikov Dmitry
 */
public class FileUtil {

/**
*       
* @param fn -  
* @param encode -   (windows-1251, utf8)
* @return  
* @throws IOException
* @throws UnsupportedEncodingException
*/
public static String loadFile(String fn, String encode) throws IOException, UnsupportedEncodingException {
String s = "";
BufferedReader r = new BufferedReader(new InputStreamReader(new FileInputStream(fn),encode));
while (r.ready()){
s += r.readLine() + '\n';
}
r.close();
return s;
}

/**
*    
* @param fname
* @param text
* @param encode
* @throws java.io.IOException
* @throws java.io.UnsupportedEncodingException
*/
public static void saveFile(String fname,String text,String encode) throws IOException, UnsupportedEncodingException {
//try {
OutputStreamWriter ow = new OutputStreamWriter(new FileOutputStream(fname),encode);
ow.write(text);
ow.close();
//} catch (Exception ex) {
//ex.printStackTrace();
//}
}

/**
*         ";"
* @param ss
* @return
*/
public static String arrayToString(String[] ss) {
String s = "";
int c = 0;
for(String i : ss) {
s += (c==0 ? "" : ";") + i;
c++;
}
return s;
}

/**
*  ,  
* @param path
* @return
*/
static public boolean deleteDirectory(File path) {
if( path.exists() ) {
File[] files = path.listFiles();
for(int i=0; i<files.length; i++) {
if(files[i].isDirectory()) {
deleteDirectory(files[i]);
}
else {
files[i].delete();
}
}
}
return( path.delete() );
}

/**
*    
* @param sourceLocation
* @param targetLocation
* @throws java.io.IOException
*/
public static void copyDirectory(File sourceLocation , File targetLocation) throws IOException {
if (sourceLocation.isDirectory()) {
if (!targetLocation.exists()) {
targetLocation.mkdir();
}
String[] children = sourceLocation.list();
for (int i=0; i<children.length; i++) {
copyDirectory(new File(sourceLocation, children[i]),
new File(targetLocation, children[i]));
}
} else {
InputStream in = new FileInputStream(sourceLocation);
OutputStream out = new FileOutputStream(targetLocation);
// Copy the bits from instream to outstream
byte[] buf = new byte[1024];
int len;
while ((len = in.read(buf)) > 0) {
out.write(buf, 0, len);
}
in.close();
out.close();
}
}

}
