/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ru.jimbot.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Properties;
import ru.jimbot.table.UserPreference;

/**
 * @author Warik777
 */
public class OtherProp {

public static HashMap<String,OtherProp> props = new HashMap<String,OtherProp>();
public String PROPS_FILE = "";
public String PROPS_FOLDER = "";
public String ENCODING = "windows-1251";
private Properties   appProps;

/** Creates a new instance of ShootingProp */
public OtherProp() {}

/**
 * @param name -  
 * @return
 */
public static OtherProp getInstance(String name){
if(props.containsKey(name)) {
return props.get(name);
} else {
OtherProp p = new OtherProp();
p.PROPS_FILE = "./services/"+name+"/shops.xml";
p.PROPS_FOLDER = "./services/"+name;
p.setDefault();
p.load();
props.put(name, p);
return p;
}
}

public void setDefault() {
appProps = new Properties();
setIntProperty("armour.weaponCount", 0/*1*/);
setIntProperty("prava.pravaCount", 0/*1*/);
setIntProperty("bot.robCount", 0/*1*/);
setIntProperty("laid.laidCount", 0/*1*/);



//setStringProperty("plain.name0", ""); //
//setIntProperty("plain.price0", 0); //
//setIntProperty("plain.criminality0", 0); // 
//setIntProperty("plain.health0", 0); // 
//setIntProperty("plain.purse0", 0); // 
//setIntProperty("plain.reward0", 0); //
}

/**
 * @param id -  
 * @return
 */
public UserPreference[] getArmourPreference(int id){
UserPreference[] p = {
new UserPreference(UserPreference.CATEGORY_TYPE, "armour"," ["+id+"]",""),
new UserPreference(UserPreference.STRING_TYPE,  "armour.name"+id," ",getStringProperty("armour.name"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "armour.price"+id," ",getIntProperty("armour.price"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "armour.health"+id,"  ",getIntProperty("armour.health"+id)),

};
return p;
}

public UserPreference[] getPravaPreference(int id){
UserPreference[] p = {
new UserPreference(UserPreference.CATEGORY_TYPE, "prava"," ["+id+"]",""),
new UserPreference(UserPreference.STRING_TYPE,  "prava.name"+id," ",getStringProperty("prava.name"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "prava.price"+id," ",getIntProperty("prava.price"+id)),
new UserPreference(UserPreference.STRING_TYPE,  "prava.pravo"+id," ",getStringProperty("prava.pravo"+id)),

};
return p;
}
public UserPreference[] getRobPreference(int id){
UserPreference[] p = {
new UserPreference(UserPreference.CATEGORY_TYPE, "rob"," ["+id+"]",""),
new UserPreference(UserPreference.STRING_TYPE,  "rob.name"+id," ",getStringProperty("rob.name"+id)),

//new UserPreference(UserPreference.STRING_TYPE,  "rob.prov"+id,"",getStringProperty("rob.prov"+id)),
new UserPreference(UserPreference.TEXTAREA_TYPE,  "rob.otv"+id," ",getStringProperty("rob.otv"+id)),


};
return p;
}

/**
 *  
 * @param id
 * @return
 */
public UserPreference[] getLaidUpPreference(int id){
UserPreference[] p = {
new UserPreference(UserPreference.CATEGORY_TYPE,"laid"," ["+id+"]",""),
new UserPreference(UserPreference.STRING_TYPE,"laid.name"+id," ",getStringProperty("laid.name"+id)),
new UserPreference(UserPreference.STRING_TYPE,"laid.general"+id,"  ",getStringProperty("laid.general"+id)),
new UserPreference(UserPreference.STRING_TYPE,"laid.personal"+id," ",getStringProperty("laid.personal"+id)),
new UserPreference(UserPreference.STRING_TYPE,"laid.answer"+id,"  ",getStringProperty("laid.answer"+id)),
};
return p;
}

/**
 *  
 * @return
 */
public int weaponCount(){
return getIntProperty("armour.weaponCount");
}
public int pravaCount(){
return getIntProperty("prava.pravaCount");
}

public int robCount(){
return getIntProperty("bot.robCount");
}

/**
 *  
 * @param i -  
 * @return
 */
public String getName(int i){
return getStringProperty("armour.name"+i);
}
public String getPravaName(int i){
return getStringProperty("prava.name"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getPrice(int i){
return getIntProperty("armour.price"+i);
}
public int getPravaPrice(int i){
return getIntProperty("prava.price"+i);
}

public String getPravaPravo(int i){
return getStringProperty("prava.pravo"+i);
}



public int getHealth(int i){
return getIntProperty("armour.health"+i);
}



//public String getRobProv(int i){
//return getStringProperty("rob.prov"+i);
//}

public String getRobOtv(int i){
return getStringProperty("rob.otv"+i);
}
public String getRobName(int i){
return getStringProperty("rob.name"+i);
}



/**
 *  
 * @param i
 * @param name - 
 * @param price - 
 * @param criminality -  
 * @param health -  
 * @param purse -  
 * @param reward - 
 */
public void setWeapon(int i, String name, int price, int health){
setStringProperty("armour.name"+i, name);
setIntProperty("armour.price"+i, price);
setIntProperty("armour.health"+i, health);

}

public void setPrava(int i, String name, int price, String pravo){
setStringProperty("prava.name"+i, name);
setIntProperty("prava.price"+i, price);
setStringProperty("prava.pravo"+i, pravo);

}

public void setRob(int i,String name, String otv){
setStringProperty("rob.name"+i, name);

//setStringProperty("rob.prov"+i,prov);
setStringProperty("rob.otv"+i,otv);


}

/**
 *   
 * @param name - 
 * @param price - 
 * @param criminality -  
 * @param health -  
 * @param purse -  
 * @param reward - 
 * @return -   
 */
public int addWeapon(String name, int price,  int health){
int c = weaponCount();
setIntProperty("armour.weaponCount",c + 1);
setStringProperty("armour.name"+c, name);
setIntProperty("armour.price" + c, price);
setIntProperty("armour.health" + c, health);
;
return c;
}
public int addPravo(String name, int price,  String pravo){
int c = pravaCount();
setIntProperty("prava.pravaCount",c + 1);
setStringProperty("prava.name"+c, name);
setIntProperty("prava.price" + c, price);
setStringProperty("prava.pravo"+c, pravo);
;
return c;
}

public int addRob(String name,String otv){
int c = robCount();
setIntProperty("bot.robCount",c + 1);
setStringProperty("rob.name"+c, name);
//setStringProperty("rob.prov"+c,prov);
setStringProperty("rob.otv"+c,otv);
;
return c;
}



/**
 *  
 * @param c
 */
public void delWeapon(int c) {
//   
for(int i=1; i<(weaponCount()-1); i++){
if(i>=c){
setStringProperty("armour.name" + i, getName(i+1));
setIntProperty("armour.price" + i, getPrice(i+1));
setIntProperty("armour.health" + i, getHealth(i+1));

}
}
//   
appProps.remove("armour.name"+(weaponCount()-1));
appProps.remove("armour.price"+(weaponCount()-1));

appProps.remove("armour.health"+(weaponCount()-1));
setIntProperty("armour.weaponCount", (weaponCount()-1));
}



public void delPrava(int c) {
//   
for(int i=1; i<(pravaCount()-1); i++){
if(i>=c){
setStringProperty("prava.name" + i, getPravaName(i+1));
setIntProperty("prava.price" + i, getPravaPrice(i+1));
setStringProperty("prava.pravo" + i, getPravaPravo(i+1));

}
}
//   
appProps.remove("prava.name"+(pravaCount()-1));
appProps.remove("prava.price"+(pravaCount()-1));
appProps.remove("prava.pravo"+(pravaCount()-1));
setIntProperty("prava.pravaCount", (pravaCount()-1));
}

public void delRob(int c) {
//   
for(int i=0; i<(robCount()-1); i++){
if(i>=c){
setStringProperty("rob.name" + i, getRobName(i+1));
//setStringProperty("rob.prov" + i, getRobProv(i+1));
setStringProperty("rob.otv" + i, getRobOtv(i+1));

}
}
//   
appProps.remove("rob.name"+(robCount()-1));

//appProps.remove("rob.prov"+(robCount()-1));
appProps.remove("rob.otv"+(robCount()-1));
setIntProperty("bot.robCount", (robCount()-1));
}






public void delallWeapon() {

for(int i=1; i<(weaponCount()-1); i++){


appProps.remove("armour.name"+i);
appProps.remove("armour.price"+i);
appProps.remove("armour.health"+i);
setIntProperty("armour.weaponCount", 1);
}
}
public void delallPrava() {

for(int i=1; i<(pravaCount()-1); i++){


appProps.remove("prava.name"+i);
appProps.remove("prava.price"+i);
appProps.remove("prava.pravo"+i);
setIntProperty("prava.pravaCount", 1);
}
}
public void delallRob() {

for(int i=0; i<(robCount()-1); i++){


appProps.remove("rob.name"+i);
//appProps.remove("rob.prov"+i);
appProps.remove("rob.otv"+i);
setIntProperty("bot.robCount", 0);
}
}


//*****************************************

    @SuppressWarnings("CallToThreadDumpStack")
public void load(  ) {
File file = new File(PROPS_FILE);
if(!file.exists()){
String[] xml = PROPS_FILE.split("/");
Log.error(xml[2] + ".xml  !");
return;
}
setDefault();
try {
FileInputStream fi = new FileInputStream(file);
appProps.loadFromXML(fi);
fi.close();
Log.info("Load DataBase XML armour Weapon");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error opening DataBase XML armour Weapon: ");
}
}

    @SuppressWarnings("CallToThreadDumpStack")
public void save() {
File file = new File(PROPS_FILE);
File dir = new File(this.PROPS_FOLDER);
try {
if(!dir.exists()) {dir.mkdirs();}
FileOutputStream fo = new FileOutputStream(file);
appProps.storeToXML(fo, "DataBase XML for jImBot properties");
fo.close();
Log.info("Save DataBase XML Plain Weapon");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error saving DataBase XML Plain Weapon: ");
}
}

    @SuppressWarnings("CallToThreadDumpStack")
public void AddXmlConfig (String name){
String Xml = "./services/" + name + "/shops.xml";
File NEW = new File(Xml);
try {
FileOutputStream fo = new FileOutputStream(NEW);
appProps.storeToXML(fo, "DataBase XML for jImBot properties");
fo.close();
Log.info(name + ".xml   !");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error saving DataBase XML Plain Weapon: ");
}
}

public Properties getProps(){
return appProps;
}

public void registerProperties(Properties _appProps) {
appProps = _appProps;
}

public String getProperty(String key) {
return appProps.getProperty(key);
}

public String getStringProperty(String key) {
return appProps.getProperty(key);
}

public String getProperty(String key, String def) {
return appProps.getProperty(key,def);
}

public void setProperty(String key, String val) {
appProps.setProperty(key,val);
}

public void setStringProperty(String key, String val) {
appProps.setProperty(key,val);
}

public void setIntProperty(String key, int val) {
appProps.setProperty(key,Integer.toString(val));
}

public void setBooleanProperty(String key, boolean val) {
appProps.setProperty(key, val ? "true":"false");
}

public int getIntProperty(String key) {
return Integer.parseInt(appProps.getProperty(key));
}

public boolean getBooleanProperty(String key) {
return Boolean.valueOf(appProps.getProperty(key)).booleanValue();
}



//****************************************************************//

/**
 *  
 * @return
 */
public int laidCount(){
return getIntProperty("laid.laidCount");
}

/**
 * 
 * @param i
 * @return
 */
public String getLaidName(int i){
return getStringProperty("laid.name"+i);
}

/**
 * 
 * @param i
 * @return
 */
public String getLaidGeneral(int i){
return getStringProperty("laid.general"+i);
}

/**
 * 
 * @param i
 * @return
 */
public String getLaidPersonal(int i){
return getStringProperty("laid.personal"+i);
}

/**
 *  
 * @param i
 * @return
 */
public String getLaidAnswer(int i){
return getStringProperty("laid.answer"+i);
}

/**
 * 
 * @param i
 * @param name
 * @param prov
 * @param otv
 */
public void setLaid(int i,String name, String general,String personal,String answer){
setStringProperty("laid.name"+i, name);
setStringProperty("laid.general"+i,general);
setStringProperty("laid.personal"+i,personal);
setStringProperty("laid.answer"+i,answer);
}

/**
 * 
 * @param name
 * @param prov
 * @param otv
 * @return
 */
public int addLaid(String name, String general, String personal,String answer){
int c = laidCount();
setIntProperty("laid.laidCount",c + 1);
setStringProperty("laid.name"+c, name);
setStringProperty("laid.general"+c,general);
setStringProperty("laid.personal"+c,personal);
setStringProperty("laid.answer"+c,answer);
return c;
}

/**
 * 
 * @param c
 */
public void delLaid(int c) {
//   
for(int i=0; i<(laidCount()-1); i++){
if(i>=c){
setStringProperty("laid.name" + i, getLaidName(i+1));
setStringProperty("laid.general" + i, getLaidGeneral(i+1));
setStringProperty("laid.personal" + i, getLaidPersonal(i+1));
setStringProperty("laid.answer" + i, getLaidAnswer(i+1));
}
}
//   
appProps.remove("laid.name"+(laidCount()-1));
appProps.remove("laid.general"+(laidCount()-1));
appProps.remove("laid.personal"+(laidCount()-1));
appProps.remove("laid.answer"+(laidCount()-1));
setIntProperty("laid.laidCount", (laidCount()-1));
}

/**
 *   
 * @param c
 */
public void delAllLaid() {
for(int i=0;i<(laidCount()+1);i++){
appProps.remove("laid.name"+i);
appProps.remove("laid.general"+i);
appProps.remove("laid.personal"+i);
appProps.remove("laid.answer"+i);
setIntProperty("laid.laidCount", 0);
}
}

//***********************************************************************//

}